msn = {}

msn.activateDevMode = false

msn.missionPoints = 0
msn.intMarkerID = 0
msn.delayedMarkerPoint = nil
msn.currentRedUnitNumber = 0
msn.currentRedGroupNumber = 0
msn.currentAirAttackGroupName = nil
msn.currentCAPTargets = 0
msn.groundAssaultBuildingCounter = 8
msn.cas_TaskingNumber = 0
msn.facaNextNumber = 0
msn.facaGName = 'FACA MQ-9 Reaper ' .. msn.facaNextNumber
msn.facaUName = 'FACA ' .. msn.facaNextNumber
msn.cas_SmokeResetTaskID = 'none'
msn.cas_MapMarkerTaskID = 'none'
msn.groupAliveCheckTaskID = 'none'
msn.cas_russianHeliEmergLandTaskID1 = 'none'
msn.cas_russianHeliEmergLandTaskID2 = 'none'
msn.aiTransportEmergLand = false
msn.aiTransportSuccess = false
msn.aiTransportValidShutdown = false
msn.aiReconSuccess = false
msn.validSlotChange = true
msn.strTargetInfo = nil
msn.strTargetInfoSmoke = nil
msn.BDA = {}


msn.event_land = {}
world.addEventHandler(msn.event_land)

msn.event_pilotDead = {}
world.addEventHandler(msn.event_pilotDead)

msn.event_engineShutdown = {}
world.addEventHandler(msn.event_engineShutdown)

msn.event_birth = {}
world.addEventHandler(msn.event_birth)

msn.event_dead = {}
world.addEventHandler(msn.event_dead)

msn.event_ejection = {}
world.addEventHandler(msn.event_ejection)

msn.event_crash = {}
world.addEventHandler(msn.event_crash)


function msn.missionInit()

		_taskingsRootPath = missionCommands.addSubMenu('Tasking')
		
		_taskingsAirPath = missionCommands.addSubMenu('Air',_taskingsRootPath)
		missionCommands.addCommand('CAP check in', _taskingsAirPath, msn.cap_CreateTasking)
		
		_taskingsGroundPath = missionCommands.addSubMenu('Ground',_taskingsRootPath)
		missionCommands.addCommand('CAS check in', _taskingsGroundPath, msn.cas_CreateTasking)
		
		
		_assetMGMTPath = missionCommands.addSubMenu('Asset management')
		missionCommands.addCommand('Respawn awacs Darkstar MP: 1000', _assetMGMTPath, msn.respawnDarkstar)
		missionCommands.addCommand('Respawn TKR Texaco (Boom) MP: 500', _assetMGMTPath, msn.respawnTexaco)
		missionCommands.addCommand('Respawn TKR Arco (Drogue) MP: 500', _assetMGMTPath, msn.respawnArco)
		missionCommands.addCommand('Buy AI FACA MQ-9 Reaper Pontiac 1 (JTAC Auto Lase) MP: 200', _assetMGMTPath, msn.respawnAIFACA)
		missionCommands.addCommand('Buy AI CAS Su-25 Uzi 1 MP: 300', _assetMGMTPath, msn.respawnAIUzi1)
		missionCommands.addCommand('Buy AI CAS Uh-1H Chevy 2 MP: 200', _assetMGMTPath, msn.respawnAIChevy21)
		missionCommands.addCommand('Buy AI CAP F-5E-3 Springfield 9 MP: 500', _assetMGMTPath, msn.respawnAISpringfield9_F5E)
		missionCommands.addCommand('Buy AI CAP F-14 Springfield 9 MP: 1000', _assetMGMTPath, msn.respawnAISpringfield9_F14)
		
		--_activeFlightsMGMTPath = missionCommands.addSubMenu('Active flights management')
		
		missionCommands.addCommand('Check Mission Points', nil, msn.mpCheck)
		
		if msn.activateDevMode == true then
			_devPath = missionCommands.addSubMenu('Dev Testing')
			missionCommands.addCommand('Destroy 1 unit in CAS target group', _devPath, msn.destroyGroup, 'Russian Ground Assault Group', true)
			missionCommands.addCommand('Destroy FACA MQ-9 Reaper', _devPath, msn.destroyGroup, 'FACA', true)
			missionCommands.addCommand('Destroy Uzi 1-1', _devPath, msn.destroyGroup, 'Uzi 1', true)
			missionCommands.addCommand('Destroy Chevy 2-1', _devPath, msn.destroyGroup, 'Chevy 2', true)
			missionCommands.addCommand('Destroy Springfield 9-1', _devPath, msn.destroyGroup, 'Springfield 9', true)
			missionCommands.addCommand('Destroy Arco', _devPath, msn.destroyGroup, 'Arco', true)
			missionCommands.addCommand('Destroy REDRECON 1', _devPath, msn.destroyGroup, 'REDRECON 1', true)
			missionCommands.addCommand('Destroy REDAITRANSPORT1', _devPath, msn.destroyGroup, 'REDAITRANSPORT1', true)
			missionCommands.addCommand('Destroy Red Attack Group 1', _devPath, msn.destroyGroup, 'Red Attack Group 1', true)
			
			msn.missionPoints = 10000
		end
		
		
		msn.flagFunc_aiReconSuccessEval()
		
		
		mist.scheduleFunction(mist.respawnGroup,{'REDAITRANSPORT1', true}, timer.getTime() + 500 + mist.random(300))
		mist.scheduleFunction(mist.respawnGroup,{'REDRECON 1', true}, timer.getTime() + 300 + mist.random(300))
		mist.scheduleFunction(msn.destroyGroup,{'REDAITRANSPORT1'}, timer.getTime() + 3)
		mist.scheduleFunction(msn.destroyGroup,{'REDRECON 1'}, timer.getTime() + 4)
		
		msn.respawnArco(true)
		
		

		
		msn.out('Mission init complete. Custom F10 Commands Available.', 5)

end

function msn.funcNextRedUnitNumber()

		msn.currentRedUnitNumber = msn.currentRedUnitNumber + 1
		return msn.currentRedUnitNumber
		

end

function msn.funcNextRedGroupNumber()

		msn.currentRedGroupNumber = msn.currentRedGroupNumber + 1
		return msn.currentRedGroupNumber
		

end

function msn.cas_CheckBDA()
		
		for k,v in pairs(msn.BDA) do
			msn.out(k .. ' x' .. v,3)
		end
		
end

function msn.event_land:onEvent(Event)

    if Event.id == world.event.S_EVENT_LAND then
	

            local Init_Name = Event.initiator:getName()
			local Init_Place = Event.place
			local Init_Unit = Unit.getByName(Event.initiator:getName())
			local Init_Unit_GroupName = Init_Unit:getGroup():getName()
			
			local strMessage = Init_Unit_GroupName .. ' has landed'
			if Init_Place then
				strMessage = strMessage .. ' at ' .. Init_Place:getName()
			end
			
			if Init_Name == 'Arco 1-1' then
			
				msn.out(strMessage .. ' for refuel/repair.', 5)
				mist.scheduleFunction(mist.respawnGroup,{'Arco', true}, timer.getTime() + 10)
						
			elseif Init_Name == 'Darkstar 1-1' then
			
				msn.out(strMessage .. ' for refuel/repair.', 5)
				mist.scheduleFunction(mist.respawnGroup,{'Darkstar', true}, timer.getTime() + 10)
				mist.scheduleFunction(mist.respawnGroup,{'Springfield 8', true}, timer.getTime() + 15)
					
			elseif Init_Name == 'Texaco 1-1' then
			
				msn.out(strMessage .. ' for refuel/repair.', 5)
				mist.scheduleFunction(mist.respawnGroup,{'Texaco', true}, timer.getTime() + 10)

			elseif Init_Name == msn.facaUName then
			
				msn.out(strMessage, 5)
				mist.scheduleFunction(msn.destroyGroup,{msn.facaGName}, timer.getTime() + 10)
			
			elseif Init_Name == 'Springfield 9-1' then
			
				msn.out(strMessage, 5)
				mist.scheduleFunction(msn.destroyGroup,{'Springfield 9'}, timer.getTime() + 10)
				
			elseif Init_Name == 'Uzi 1-1' then
				
				msn.out(strMessage, 5)
				mist.scheduleFunction(msn.destroyGroup,{'Uzi 1'}, timer.getTime() + 10)
				
			elseif Init_Name == 'Chevy 2-1' then
				
				msn.out(strMessage, 5)
				mist.scheduleFunction(msn.destroyGroup,{'Chevy 2'}, timer.getTime() + 10)
				
			elseif Init_Name == 'Springfield 8-1' then
			
				msn.out(strMessage, 5)
				local groupName = 'Darkstar'
				if Group.getByName(groupName) and Group.getByName(groupName):isExist() == true and Group.getByName(groupName):getSize() > 0 then
					mist.scheduleFunction(mist.respawnGroup,{'Springfield 8', true}, timer.getTime() + 10)
				else
					mist.scheduleFunction(msn.destroyGroup,{'Springfield 8'}, timer.getTime() + 10)
				end
					
				
				
				
			elseif Init_Name == 'transport1' then
				
				if Event.place then
					
					msn.aiTransportValidShutdown = true
					if msn.aiTransportSuccess == false then
						msn.out('The Russian Mi-26 was forced to leave the AO unsuccessful', 10)
						msn.mpUpdate(100)
					else
						msn.aiTransportSuccess = false
						msn.out('The Russian Mi-26 has escaped the AO successful', 10)
						msn.mpUpdate(-50)
					end
					
					mist.scheduleFunction(msn.destroyGroup,{'REDAITRANSPORT1'}, timer.getTime() + 50)
					mist.scheduleFunction(mist.respawnGroup,{'REDAITRANSPORT1', true}, timer.getTime() + 60)
					
				else
				
					if msn.aiTransportSuccess == false then
						ulPoint = Unit.getByName(Init_Name):getPoint()
						ctld.spawnGroupAtPoint('red', {mg=2,at=1,inf=5}, ulPoint, 5000)
						msn.out('The Russian Mi-26 was seen landing troops in close proximity to the depot! Huey pilots should prioritize landing own troops in the area to hunt them down!', 10)
						msn.aiTransportSuccess = true
						msn.mpUpdate(-50)
					end
						
				end
				
				
				
			elseif Init_Name == 'REDRECON 1-1' then
				
				mist.scheduleFunction(msn.destroyGroup,{'REDRECON 1'}, timer.getTime() + 10)
				
				if msn.aiReconSuccess == true then
				
					msn.out('The Russian Su-24 intelligence flight successfully escaped the AO with gathered intel', 10)
					msn.mpUpdate(-100)
					msn.aiReconSuccess = false
					mist.scheduleFunction(mist.respawnGroup,{'REDRECON 1', true}, timer.getTime() + 20)
					
				else
				
					msn.out('The Russian Su-24 intelligence flight was forced to RTB without intel', 10)
					msn.mpUpdate(50)
					mist.scheduleFunction(mist.respawnGroup,{'REDRECON 1', true}, timer.getTime() + 300)
					
				end
					
			end

			if string.match(Init_Name,'Red Fighter Unit') then
			
					mist.scheduleFunction(msn.destroyGroup,{Init_Unit_GroupName}, timer.getTime() + 10)
					msn.currentCAPTargets = msn.currentCAPTargets - 1
					msn.cap_EvalTaskComplete()
				
			elseif string.match(Init_Name,'Red Bomber Unit') then

					mist.scheduleFunction(msn.destroyGroup,{Init_Unit_GroupName}, timer.getTime() + 10)			
					msn.currentCAPTargets = msn.currentCAPTargets - 1
					msn.cap_EvalTaskComplete()
					
			elseif string.match(Init_Name,'Red Attack Unit') then

					mist.scheduleFunction(msn.destroyUnit,{Init_Name}, timer.getTime() + 10)
					msn.currentCAPTargets = msn.currentCAPTargets - 1
					msn.cap_EvalTaskComplete()
					
			end
			
        
		
    end
	
end
	
function msn.event_pilotDead:onEvent(Event)

	if Event.id == world.event.S_EVENT_PILOT_DEAD then
	
		if Event.initiator then

			local Init_Name = Event.initiator:getName()
				
			if Init_Name == 'Chevy 2-1' then
				msn.out('UH-1H Chevy 2 were KIA', 5)
			elseif Init_Name == 'Uzi 1-1' then
				msn.out('Su-25 Uzi 1 were KIA', 5)
			elseif Init_Name == 'Springfield 9-1' then
				msn.out('F-5E-3 Springfield 9 were KIA', 5)
			end
			
		end
			
	end
			
end


function msn.event_crash:onEvent(Event)

	if Event.id == world.event.S_EVENT_CRASH then
	
		if Event.initiator then
		
			local Init_Name = Event.initiator:getName()
			local Init_Group_Name = Event.initiator:getGroup():getName()
			
			
			if Init_Name == 'REDRECON 1-1' then
			
					msn.out('Enemy reconnaissance aircraft defeated.', 5)
					msn.mpUpdate(200)
					mist.scheduleFunction(mist.respawnGroup,{'REDRECON 1', true}, timer.getTime() + 600)
			
			elseif Init_Name == 'transport1' then
			
					if msn.aiTransportEmergLand == true then
						msn.out('The downed enemy transport helicopter was completely destroyed', 5)
						msn.mpUpdate(100)
						msn.aiTransportEmergLand = false
						msn.aiTransportSuccess = false
						mist.removeFunction(msn.cas_russianHeliEmergLandTaskID1)
						mist.removeFunction(msn.cas_russianHeliEmergLandTaskID2)
						mist.scheduleFunction(mist.respawnGroup,{'REDAITRANSPORT1', true}, timer.getTime() + 600 + mist.random(300))
						return
					end
				
					msn.out('Enemy transport helicopter defeated', 5)
					if msn.aiTransportSuccess == false then
							
							msn.mpUpdate(200)
							mist.scheduleFunction(mist.respawnGroup,{'REDAITRANSPORT1', true}, timer.getTime() + 600 + mist.random(300))					
					else
							msn.mpUpdate(100)
							msn.aiTransportSuccess = false
							mist.scheduleFunction(mist.respawnGroup,{'REDAITRANSPORT1', true}, timer.getTime() + 600 + mist.random(300))
					end
			
			elseif Init_Name == msn.facaUName then
				msn.out('FACA MQ-9 Reaper was destroyed', 5)
			end
			
			if string.match(Init_Name,'Red Fighter Unit') then
				msn.out('Enemy fighter defeated.', 5)
				msn.mpUpdate(500)
				msn.currentCAPTargets = msn.currentCAPTargets - 1
				msn.cap_EvalTaskComplete()
			elseif string.match(Init_Name,'Red Bomber Unit') then
				msn.out('Enemy bomber defeated.', 5)
				msn.mpUpdate(300)
				msn.currentCAPTargets = msn.currentCAPTargets - 1
				msn.cap_EvalTaskComplete()
			elseif string.match(Init_Name,'Red Attack Unit') then
				msn.out('Enemy attack aircraft defeated.', 5)
				msn.mpUpdate(300)
				msn.currentCAPTargets = msn.currentCAPTargets - 1
				msn.cap_EvalTaskComplete()
			end
				
			
		end
			
	end
	
end


function msn.cap_EvalTaskComplete()

		if msn.currentCAPTargets == 0 then
			msn.currentAirAttackGroupName = nil
			missionCommands.addCommand('CAP check in', _taskingsAirPath, msn.cap_CreateTasking)
			msn.out('Current CAP situation resolved. Check in again when ready on station', 10)
		end

end



function msn.facaStart()

	if ctld.jtacUnits[msn.facaGName] ~= nil and Group.getByName(msn.facaGName) and Group.getByName(msn.facaGName):isExist() == true and Group.getByName(msn.facaGName):getSize() > 0 and Group.getByName(msn.facaGName):getUnit(1):isActive() == true then
		msn.out('FACA MQ-9 Reaper already providing prioritized target lasing',3)
		return
	end

	if Group.getByName(msn.facaGName) and Group.getByName(msn.facaGName):isExist() == true and Group.getByName(msn.facaGName):getSize() > 0 and Group.getByName(msn.facaGName):getUnit(1):isActive() == true and ctld.jtacUnits[msn.facaGName] == nil then
		ctld.JTACAutoLase(msn.facaGName, 1688)
	else
		msn.out('FACA MQ-9 Reaper not available',3)
	end

end

function msn.facaStop()

	ctld.JTACAutoLaseStop(msn.facaGName)


end

function msn.event_ejection:onEvent(Event)

	if Event.id == world.event.S_EVENT_EJECTION then
	
		local Init_Name = Event.initiator:getName()
		
		if Init_Name == 'Uzi 1-1' then
			msn.out('Su-25 Uzi 1 ejected.', 5)
		elseif Init_Name == 'Springfield 9-1' then
			msn.out('F-5E-3 Springfield 9 ejected.', 5)				
		end
	
	end
	
end

function msn.event_engineShutdown:onEvent(Event)
		
	if Event.id == world.event.S_EVENT_ENGINE_SHUTDOWN then
	

			local Init_Name = Event.initiator:getName()
			if Init_Name == 'transport1' then
			
				if msn.aiTransportValidShutdown == false then
				
					msn.out('Enemy transport helicopter was seen making an emergency landing in the AO. Marked with red smoke! Find it and destroy it completely before the enemy can recover it!', 15)
					local units = {'transport1'}
					local vec3pos = mist.getAvgPos(units)
					local smokePos = mist.getRandPointInCircle(vec3pos, 100, 50)
					smokePos = mist.utils.makeVec3(smokePos, vec3pos.y)
					trigger.action.smoke(smokePos, 1)
					msn.aiTransportEmergLand = true
					msn.mpUpdate(100)
					msn.cas_russianHeliEmergLandTaskID1 = mist.scheduleFunction(mist.respawnGroup,{'REDAITRANSPORT1', true}, timer.getTime() + 300)
					msn.cas_russianHeliEmergLandTaskID2 = mist.scheduleFunction(msn.out,{'The downed enemy transport helicopter and crew was recovered by enemy ground assets'}, timer.getTime() + 300)
					
				end
				
			end
			
	end
	
end

function msn.event_birth:onEvent(Event)
			

				
	if Event.id == world.event.S_EVENT_BIRTH then
	

		
			local Init_Name = Event.initiator:getName()
			if Init_Name == 'REDRECON 1-1' then
			
				msn.aiTransportValidShutdown = false
				
			end
			
	end
	
end
	

function msn.event_dead:onEvent(Event) --for ground units only
	
	if Event.id == world.event.S_EVENT_DEAD then
	
			local Init_Unit = Event.initiator
			local Init_Name = Init_Unit:getName()
			local Init_Type = Init_Unit:getTypeName()
			if not Init_Type then
					Init_Type = 'Unknown'
				end
			
			if string.match(Init_Name, 'Russian Ground Assault Group') then
			
				
				if not msn.BDA[Init_Type] then
					msn.BDA[Init_Type]=1
					
				else
					msn.BDA[Init_Type] = msn.BDA[Init_Type]+1
					
				end		
				
				if string.match(Init_Type:lower(), 'soldier') then
					msn.mpUpdate(5,nil,true)
				else
					msn.mpUpdate(20,nil,true)
				end
				return
			else
				if string.match(Init_Type:lower(), 'soldier') then
					msn.mpUpdate(5,nil,true)
				end
			end
					
	end
	
end


function msn.destroyGroup(strGroupName, devCommand)

	if devCommand then
	
		--msn.out("msn.destroyGroup('" .. strGroupName .. "')",3)
		
		local objUnit
		if strGroupName == 'FACA' then
			objUnit = Group.getByName(msn.facaGName):getUnit(1)
		else
			objUnit = Group.getByName(strGroupName):getUnit(1)
		end
		
		local unitPoint = objUnit:getPoint()
		trigger.action.explosion(unitPoint, 100)
	
	else
		Group.getByName(strGroupName):destroy()
	end
	

end

function msn.destroyUnit(strUnitName, devCommand)

	local objUnit = Unit.getByName(strUnitName)

	if devCommand then
	
		local unitPoint = objUnit:getPoint()
		trigger.action.explosion(unitPoint, 100)
	
	else
		objUnit:destroy()
	end
	

end


function msn.mpUpdate(mp, boolPointsUsed, boolSilentUpdate)

	if boolSilentUpdate == nil then
		boolSilentUpdate = false
	end
	if boolPointsUsed == nil then
		boolPointsUsed = false
	end

	local intResult = msn.missionPoints + mp
	if intResult > 0 then

		msn.missionPoints = msn.missionPoints + mp

	else

		msn.missionPoints = 0

	end
	
	if boolSilentUpdate == false then
	
		if mp > 0 then
			msn.out('Mission Points Added: +'.. mp, 5)
		else
			if boolPointsUsed == false then
				msn.out('Mission Points Lost: '.. mp, 5)
			else
				msn.out('Mission Points Used: '.. mp, 5)
			end
		end		
		msn.out('Current Mission Points: '.. msn.missionPoints, 5)
		
	end

end



function msn.cas_CreateTasking()

	if msn.cas_TaskingNumber == 0 then
		msn.flagFunc_groundAssaultSuccessEval()
	end

	msn.cas_TaskingNumber = msn.cas_TaskingNumber + 1
	
	missionCommands.removeItem({'Tasking', 'Ground', 'CAS check in'})
	
	msn.out('Roger CAS on station, stand by for tasking.',10)

	local randomNumber = mist.random(2) --randomize CAS tasking type: 1=Assault Force;2=Artillery
	if randomNumber == 1 then
		mist.scheduleFunction(msn.cas_SpawnGroundAssaultGroup,{},timer.getTime()+15+mist.random(15))
	else
		mist.scheduleFunction(msn.cas_SpawnGroundArty,{},timer.getTime()+15+mist.random(15))
	end


end

function msn.cas_SpawnGroundAssaultGroup()


		local unitType = nil
		local irSAMCount = 0
		local aaaCount = 0
		local activeSpawnZoneNumber = mist.random(3)
		local activeSpawnZone = trigger.misc.getZone('AI Ground Spawn Zone ' .. activeSpawnZoneNumber)
		local groupSpawnPoint
		
		repeat --Find a random spot of LAND within the large AO zone
				groupSpawnPoint = mist.getRandPointInCircle(activeSpawnZone.point, activeSpawnZone.radius)
		until land.getSurfaceType(groupSpawnPoint) == land.SurfaceType.LAND
		

		local units = {}
		local groupSize = mist.random(4,8)
		local unitsCount = 0
		
		repeat
					
				local randomNumber = mist.random(11)
				local priority = ''
			
				if randomNumber == 1 then
					if irSAMCount < 1 then
						unitType = 'Strela-1 9P31'
						unitsCount = unitsCount + 1
						irSAMCount = irSAMCount + 1
						priority = 'hpriority'
					end
				elseif randomNumber == 2 then
					if irSAMCount < 1 then
						unitType = 'Strela-10M3'
						unitsCount = unitsCount + 1
						irSAMCount = irSAMCount + 1
						priority = 'hpriority'
					end
				elseif randomNumber == 3 then
					if aaaCount < 2 then
						unitType = 'Ural-375 ZU-23'
						unitsCount = unitsCount + 1
						aaaCount = aaaCount + 1
						priority = 'priority'
					end
				elseif randomNumber == 4 then
					if aaaCount < 2 then
						unitType = 'ZSU-23-4 Shilka'
						unitsCount = unitsCount + 1
						aaaCount = aaaCount + 1
						priority = 'priority'
					end
				elseif randomNumber == 5 then
					unitType = 'BTR-80'
					unitsCount = unitsCount + 1
				elseif randomNumber == 6 then
					unitType = 'BMD-1'
					unitsCount = unitsCount + 1
				elseif randomNumber == 7 then
					unitType = 'BMP-1'
					unitsCount = unitsCount + 1
				elseif randomNumber == 8 then
					unitType = 'BRDM-2'
					unitsCount = unitsCount + 1
				elseif randomNumber == 9 then
					unitType = 'T-55'
					unitsCount = unitsCount + 1
				elseif randomNumber == 10 then
					unitType = 'Tigr_233036'
					unitsCount = unitsCount + 1
				elseif randomNumber == 11 then
					unitType = 'Ural-4320T'
					unitsCount = unitsCount + 1
				end
							
				if unitType ~= nil then
				
						repeat --Place every unit within a 100m radius circle from the groupSpawnPoint previously randomly chosen
								unitPosition = mist.getRandPointInCircle(groupSpawnPoint, 100)
						until land.getSurfaceType(unitPosition) == land.SurfaceType.LAND
								

						table.insert(units,
						{
							["x"] = unitPosition.x,
							["y"] = unitPosition.y,
							["type"] = unitType,
							["name"] = 'Russian Ground Assault Group Unit ' .. unitsCount .. ' ' .. priority,
							["heading"] = mist.random(359),
							["skill"] = "Random"
						})
						
						unitType = nil
						
				end
							
		until unitsCount == groupSize
					

				
		mist.dynAdd({country = 'RUSSIA', category = 'GROUND_UNIT', name = 'Russian Ground Assault Group', hidden = true, units = units }) --Create and spawn the group
		mist.scheduleFunction(msn.cas_GroundGroupAliveCheck,{},timer.getTime()+10)
		mist.scheduleFunction(mist.groupToPoint,{'Russian Ground Assault Group', 'Objective Zone', 'On Road', nil, 40, true},timer.getTime()+15)

		
		if activeSpawnZoneNumber == 1 then
			msn.strTargetInfo = 'Locate and destroy a column of ' .. groupSize .. ' vehicles advancing on road towards the depot from a northern direction.'
		elseif activeSpawnZoneNumber == 2 then
			msn.strTargetInfo = 'Locate and destroy a column of ' .. groupSize .. ' vehicles advancing on road towards the depot from a north eastern direction.'
		else
			msn.strTargetInfo = 'Locate and destroy a column of ' .. groupSize .. ' vehicles advancing on road towards the depot from an eastern direction.'
		end
		
		msn.out('New CAS Tasking:',10)
		msn.cas_SmokeMarkerAssaultGroup('auto', activeSpawnZoneNumber)
		
		--mist.scheduleFunction(msn.FACEngageGroup,{},timer.getTime()+5)
		
		missionCommands.addCommand('Target information', _taskingsGroundPath, msn.cas_TargetInfo)
		missionCommands.addCommand('Start FACA Prioritized Target Lasing', _taskingsGroundPath, msn.facaStart)
		missionCommands.addCommand('Stop FACA Prioritized Target Lasing', _taskingsGroundPath, msn.facaStop)
		missionCommands.addCommand('Request BDA', _taskingsGroundPath, msn.cas_CheckBDA)
		
		mist.scheduleFunction(msn.cas_MapMarker,{true},timer.getTime()+2)
		
		
	

end



function msn.cas_SpawnGroundArty()


		local unitType = nil
		local irSAMCount = 0
		local aaaCount = 0
		local artyCount = 0
		local activeArtySpawnZoneNumber = mist.random(40)
		local activeSpawnZone = trigger.misc.getZone('artyZone ' .. activeArtySpawnZoneNumber)
		local groupSpawnPoint
		local randomNumber
		
		repeat --Find a random point of LAND within the active spawn zone
				groupSpawnPoint = mist.getRandPointInCircle(activeSpawnZone.point, activeSpawnZone.radius)
		until land.getSurfaceType(groupSpawnPoint) == land.SurfaceType.LAND
		
		local units = {}
		local unitsCount = 0
		local groupSize = mist.random(8,12)

		repeat
		
				local priority = ''
				
				if unitsCount == 0 then
					randomNumber = 1
				else
					randomNumber = mist.random(9)
				end
	
						
					
				if randomNumber == 1 then
					if artyCount < 2 then
						unitType = 'SAU Gvozdika'
						artyCount = artyCount + 1
						unitsCount = unitsCount + 1
						priority = ' priority'
					end	
				elseif randomNumber == 2 then
					unitType = 'GAZ-66'
					unitsCount = unitsCount + 1
				elseif randomNumber == 3 then
					unitType = 'Ural-4320T'
					unitsCount = unitsCount + 1
				elseif randomNumber == 4 then
					unitType = 'ATMZ-5'
					unitsCount = unitsCount + 1
				elseif randomNumber == 5 then
					unitType = 'UAZ-469'
					unitsCount = unitsCount + 1
				elseif randomNumber == 6 then
					if irSAMCount < 1 then
						unitType = 'Strela-1 9P31'
						unitsCount = unitsCount + 1
						irSAMCount = irSAMCount + 1
						priority = ' hpriority'
					end
				elseif randomNumber == 7 then
					if irSAMCount < 1 then
						unitType = 'Strela-10M3'
						unitsCount = unitsCount + 1
						irSAMCount = irSAMCount + 1
						priority = ' hpriority'
					end
				elseif randomNumber == 8 then
					if aaaCount < 2 then
						unitType = 'Ural-375 ZU-23'
						unitsCount = unitsCount + 1
						aaaCount = aaaCount + 1
						priority = ' priority'
					end
				elseif randomNumber == 9 then
					if aaaCount < 2 then
						unitType = 'ZSU-23-4 Shilka'
						unitsCount = unitsCount + 1
						aaaCount = aaaCount + 1
						priority = ' priority'
					end
				end
				
				if unitType ~= nil then
							
						repeat --Place every unit within a 50m radius circle from the groupSpawnPoint previously randomly chosen
								unitPosition = mist.getRandPointInCircle(groupSpawnPoint, 50)
						until land.getSurfaceType(unitPosition) == land.SurfaceType.LAND
						
						table.insert(units,
						{
							["x"] = unitPosition.x,
							["y"] = unitPosition.y,
							["type"] = unitType,
							["name"] = 'Russian Ground Assault Group Unit ' .. unitsCount .. priority,
							["heading"] = mist.random(359),
							["skill"] = "Random"
						})
						
						unitType = nil
						
				end
							
		until unitsCount == groupSize
	
		repeat
		
			unitsCount = unitsCount + 1
		
			unitType = 'Infantry AK'
			repeat --Place every unit within a 50m radius circle from the groupSpawnPoint previously randomly chosen
					unitPosition = mist.getRandPointInCircle(groupSpawnPoint, 50)
			until land.getSurfaceType(unitPosition) == land.SurfaceType.LAND
			
			table.insert(units,
				{
					["x"] = unitPosition.x,
					["y"] = unitPosition.y,
					["type"] = unitType,
					["name"] = 'Russian Ground Assault Group Unit ' .. unitsCount,
					["heading"] = mist.random(359),
					["skill"] = "Random"
				}
			)
		
		
					
		until unitsCount == groupSize * 3
				
		mist.dynAdd({country = 'RUSSIA', category = 'GROUND_UNIT', name = 'Russian Ground Assault Group', hidden = true, units = units }) --Create and spawn the group

		mist.scheduleFunction(msn.cas_GroundGroupAliveCheck,{},timer.getTime()+10)
		mist.scheduleFunction(msn.cas_ArtyFireAtPoint,{},timer.getTime()+15)
		mist.scheduleFunction(msn.cas_SpawnGroundArtyNotify,{1,groupSize},timer.getTime()+15+mist.random(15))
		

		

end

function msn.cas_MapMarker(boolUpdate, intID)

	if msn.delayedMarkerPoint then

			if intID then
				trigger.action.removeMark(intID)
			end
			msn.intMarkerID = msn.intMarkerID + 1
			trigger.action.markToAll(msn.intMarkerID, 'Enemy activity (Observe 1 minute intel delay)', msn.delayedMarkerPoint, true)
			
			if boolUpdate then
				msn.delayedMarkerPoint = Group.getByName('Russian Ground Assault Group'):getUnit(1):getPoint()
				msn.cas_MapMarkerTaskID = mist.scheduleFunction(msn.cas_MapMarker,{true,msn.intMarkerID},timer.getTime()+60)
			else
				msn.delayedMarkerPoint = nil
			end
			
	else
			
			msn.delayedMarkerPoint = Group.getByName('Russian Ground Assault Group'):getUnit(1):getPoint()
			
			if boolUpdate then
				msn.cas_MapMarkerTaskID = mist.scheduleFunction(msn.cas_MapMarker,{true},timer.getTime()+60)
			else
				msn.cas_MapMarkerTaskID = mist.scheduleFunction(msn.cas_MapMarker,{},timer.getTime()+60)
			end
			
	end

end

function msn.cas_SpawnGroundArtyNotify(msgnr, groupSize)

	if msgnr == 1 then
	
		msn.out('The depot are taking artillery fire! Trying to locate artillery position. Stand by...',5)
		mist.scheduleFunction(msn.cas_SpawnGroundArtyNotify,{2,groupSize},timer.getTime()+30+mist.random(30))
		
	else
	
		local groupName = 'Russian Ground Assault Group'
		if Group.getByName(groupName) and Group.getByName(groupName):isExist() == true and Group.getByName(groupName):getSize() > 0 then

			local units = {Group.getByName('Russian Ground Assault Group'):getUnit(1):getName()}
			local ref = mist.utils.makeVec3(mist.DBs.missionData.bullseye.blue, 0)
			local avgPos = mist.getAvgPos(units)

			local vec = {x = avgPos.x - ref.x, y = avgPos.y - ref.y, z = avgPos.z - ref.z}
			local dir = mist.utils.round(mist.utils.toDegree(mist.utils.getDir(vec, ref)), 0)
			local dist = mist.utils.get2DDist(avgPos, ref)
			local distMetric = mist.utils.round(dist/1000, 0)
			local distImperial = mist.utils.round(mist.utils.metersToNM(dist), 0)
			
			dir = string.format('%03d', dir)
		
			msn.out('New CAS Tasking:', 10)
			msn.strTargetInfo = 'Search for artillery group of roughly ' .. groupSize .. ' vehicles and twice as many troops, at bulls ' .. dir .. ' for ' .. distMetric .. 'km/' .. distImperial .. 'nm'
			msn.cas_SmokeMarkerArty('auto')
			
			missionCommands.addCommand('Target information', _taskingsGroundPath, msn.cas_TargetInfo)
			missionCommands.addCommand('Start FACA Prioritized Target Lasing', _taskingsGroundPath, msn.facaStart)
			missionCommands.addCommand('Stop FACA Prioritized Target Lasing', _taskingsGroundPath, msn.facaStop)
			missionCommands.addCommand('Request BDA', _taskingsGroundPath, msn.cas_CheckBDA)
			
			mist.scheduleFunction(msn.cas_MapMarker,{},timer.getTime()+5)
			
			
			
		end
		
		
	end


end





function msn.cas_TaskCompleted()

	
	if msn.cas_SmokeResetTaskID ~= 'none' then
		mist.removeFunction(msn.cas_SmokeResetTaskID)
	end
	
	if msn.cas_MapMarkerTaskID ~= 'none' then
		mist.removeFunction(msn.cas_MapMarkerTaskID)
	end
	msn.delayedMarkerPoint = nil
	trigger.action.removeMark(msn.intMarkerID)
	
	msn.strTargetInfo = nil
	msn.strTargetInfoSmoke = nil
	msn.BDA = {}
	
	missionCommands.addCommand('CAS check in', _taskingsGroundPath, msn.cas_CreateTasking)
	missionCommands.removeItem({'Tasking', 'Ground', 'Target information'})
	missionCommands.removeItem({'Tasking', 'Ground', 'Request BDA'})
	missionCommands.removeItem({'Tasking', 'Ground', 'Request smoke on target area (MP: -25)'})
	missionCommands.removeItem({'Tasking', 'Ground', 'Request smoke marker on objective road (MP: -25)'})
	missionCommands.removeItem({'Tasking', 'Ground', 'Start FACA Prioritized Target Lasing'})
	missionCommands.removeItem({'Tasking', 'Ground', 'Stop FACA Prioritized Target Lasing'})
	msn.out('Russian ground force was defeated! You may now request a new tasking.', 10)
	msn.mpUpdate(250)
	

end

function msn.cas_SmokeMarkerArty(triggerType)

		local objunit = Group.getByName('Russian Ground Assault Group'):getUnit(1)
		local groupPoint = objunit:getPoint()
		local smokePos = mist.getRandPointInCircle(groupPoint, 200,199)
		smokePos = mist.utils.makeVec3(smokePos, groupPoint.y)
		

		local vec = {x = groupPoint.x - smokePos.x, y = groupPoint.y - smokePos.y, z = groupPoint.z - smokePos.z}
		local dir = mist.utils.round(mist.utils.toDegree(mist.utils.getDir(vec, smokePos)), 0)
		dir = string.format('%03d', dir)
		
		--local vec3pos = mist.getAvgPos(mist.makeUnitTable({'[g]Russian Ground Assault Group'})) --commented out because 31682 - Client groups not accessible in multiplayer. Uncomment and delete below 2 lines when fixed.
		--local units = {'Russian Ground Assault Group Unit 1', 'Russian Ground Assault Group Unit 2', 'Russian Ground Assault Group Unit 3', 'Russian Ground Assault Group Unit 4', 'Russian Ground Assault Group Unit 5', 'Russian Ground Assault Group Unit 6', 'Russian Ground Assault Group Unit 7', 'Russian Ground Assault Group Unit 8'}
		--local vec3pos = mist.getAvgPos(units)
		
		
		--Deploy 3 white smoke on the target area
		--smokePos = mist.getRandPointInCircle(vec3pos, 200)
		--smokePos = mist.utils.makeVec3(smokePos, vec3pos.y)
		
	
		
		if triggerType == 'auto' then
		
			trigger.action.smoke(smokePos, 1)
			msn.strTargetInfoSmoke = 'The target is RED smoke, ' .. dir .. ', 200m!'
			msn.cas_TargetInfo()
		
		else
			
			if msn.missionPoints > 25 then
				msn.mpUpdate(-25, true, nil)
				missionCommands.removeItem({'Tasking', 'Ground', 'Request smoke on target area (MP: -25)'})
				msn.strTargetInfoSmoke = 'The target is RED smoke, ' .. dir .. ', 200m!'
				mist.scheduleFunction(trigger.action.smoke,{smokePos, 1}, timer.getTime() + 5)
				mist.scheduleFunction(msn.out,{'The target is RED smoke, ' .. dir .. ', 200m!', 5}, timer.getTime() + 6)
			else
				msn.out('Insufficient mission points. Required: 25, Available: ' .. msn.missionPoints,5)
			end
				
		
		end
		msn.cas_SmokeResetTaskID = mist.scheduleFunction(msn.cas_SmokeReset,{'Arty'}, timer.getTime() + 300)

		
end

function msn.cas_SmokeMarkerAssaultGroup(triggerType, loc)

		local objZone
		if loc == 1 then
			objZone = trigger.misc.getZone('smokeMarkerZoneN')
		elseif loc == 2 then
			objZone = trigger.misc.getZone('smokeMarkerZoneNE')
		else
			objZone = trigger.misc.getZone('smokeMarkerZoneE')
		end
		
		if triggerType == 'auto' then
		
			trigger.action.smoke(objZone.point, 1)
			msn.strTargetInfoSmoke = 'The road to scan for assaulting vehicles is marked by red smoke!'
			msn.cas_TargetInfo()
		
		else
			
			if msn.missionPoints > 25 then
				msn.mpUpdate(-25, true, nil)
				missionCommands.removeItem({'Tasking', 'Ground', 'Request smoke marker on objective road (MP: -25)'})
				msn.strTargetInfoSmoke = 'The road to scan for assaulting vehicles is marked by red smoke!'
				mist.scheduleFunction(trigger.action.smoke,{objZone.point, 1}, timer.getTime() + 5)
				mist.scheduleFunction(msn.out,{msn.strTargetInfoSmoke, 5}, timer.getTime() + 6)
			else
				msn.out('Insufficient mission points. Required: 25, Available: ' .. msn.missionPoints,5)
			end
				
		
		end
		msn.cas_SmokeResetTaskID = mist.scheduleFunction(msn.cas_SmokeReset,{nil, loc}, timer.getTime() + 300)

		
end


function msn.cas_SmokeReset(taskType, loc)

		msn.strTargetInfoSmoke = nil
		if taskType == 'Arty' then
			missionCommands.addCommand('Request smoke on target area (MP: -25)', _taskingsGroundPath, msn.cas_SmokeMarkerArty, 'manual')
			msn.out('You can now request another smoke drop on the target. (MP: -25)',5)
		else
			missionCommands.addCommand('Request smoke marker on objective road (MP: -25)', _taskingsGroundPath, msn.cas_SmokeMarkerAssaultGroup, 'manual', loc)
			msn.out('You can now request another smoke marker on the objective road. (MP: -25)',5)
		end
		
		
end


function msn.cas_GroundGroupAliveCheck()

	local groupName = 'Russian Ground Assault Group'
	if Group.getByName(groupName) and Group.getByName(groupName):isExist() == true and Group.getByName(groupName):getSize() > 0 then
		mist.scheduleFunction(msn.cas_GroundGroupAliveCheck,{},timer.getTime()+10)
	else
		ctld.JTACAutoLaseStop(msn.facaGName)
		msn.cas_TaskCompleted()
	end
	

end




function msn.flagFunc_groundAssaultSuccessEval()

	mist.flagFunc.units_in_zones{ 
		units = {'Russian Ground Assault Group Unit 1', 'Russian Ground Assault Group Unit 2', 'Russian Ground Assault Group Unit 3', 'Russian Ground Assault Group Unit 4', 'Russian Ground Assault Group Unit 5', 'Russian Ground Assault Group Unit 6', 'Russian Ground Assault Group Unit 7', 'Russian Ground Assault Group Unit 8'}, 
		zones = {'Objective Zone'}, 
		flag = 90,
		toggle = true,
		stopflag = 91,
	}
	
end

function msn.flagFunc_aiReconSuccessEval()

	mist.flagFunc.units_in_zones{ 
		units = {'REDRECON 1-1'}, 
		zones = {'Objective Zone'}, 
		flag = 95,
		toggle = true,
		stopflag = 96,
	}
	
end

function msn.flagFunc_in_formation_enemy_transport(unitName)

	mist.flagFunc.units_in_moving_zones{
		 units = {'[blue][plane]'},
		 zone_units = {unitName}, 
		 flag = 100, 
		 radius = 20,
		 --stopFlag = 101, 
		 zone_type = 'sphere', 
		 toggle = true,

	}

end


function msn.cas_ArtyFireAtPoint()

		local zonePos= mist.utils.zoneToVec3('Objective Zone')
		local firingPoint = mist.utils.makeVec2(zonePos)

		FireAtPointControlledTask = {												
			id = 'FireAtPoint', 
			params = { 
				point = firingPoint,
				zoneRadius = 400,
				expendQtyEnabled = true,
				expendQty = 100,
			} 
		}
		Group.getByName('Russian Ground Assault Group'):getController():pushTask(FireAtPointControlledTask)

end


function msn.respawnTexaco()

	if msn.missionPoints >= 500 then
		msn.mpUpdate(-500, true)
		msn.out('Another boom type TANKER is on the way!',5)
		mist.respawnGroup('Texaco', true)
	else
		msn.out('Insufficient mission points. Required: 500, Available: ' .. msn.missionPoints,5)
	end

end

function msn.respawnArco(bStart)

	if not bStart then

		if msn.missionPoints >= 500 then
			msn.mpUpdate(-500, true)
			msn.out('Another drogue type TANKER is on the way!',5)
		else
			msn.out('Insufficient mission points. Required: 500, Available: ' .. msn.missionPoints,5)
			return
		end
		
	end
	
	
	mist.scheduleFunction(mist.dynAdd,{{country = 'USA', category = 'AIRPLANE',
	
	["lateActivation"] = false,
	["tasks"] = 
	{
	}, -- end of ["tasks"]
	["radioSet"] = false,
	["task"] = "Refueling",
	["uncontrolled"] = false,
	["taskSelected"] = true,
	["y"] = 646373.17498617,
	["x"] = -281607.28417614,
	["name"] = "Arco",
	["communication"] = true,
	["modulation"] = 0,
	["frequency"] = 251,
	["hidden"] = false,
	["route"] = 
	{
		["routeRelativeTOT"] = true,
		["points"] = 
		{
			[1] = 
			{
				["alt"] = 13,
				["action"] = "From Parking Area Hot",
				["alt_type"] = "BARO",
				["speed"] = 138.88888888889,
				["task"] = 
				{
					["id"] = "ComboTask",
					["params"] = 
					{
						["tasks"] = 
						{
							[1] = 
							{
								["number"] = 1,
								["auto"] = true,
								["id"] = "Tanker",
								["enabled"] = true,
								["params"] = 
								{
								}, -- end of ["params"]
							}, -- end of [1]
							[2] = 
							{
								["enabled"] = true,
								["auto"] = false,
								["id"] = "WrappedAction",
								["number"] = 2,
								["params"] = 
								{
									["action"] = 
									{
										["id"] = "ActivateBeacon",
										["params"] = 
										{
											["type"] = 4,
											["AA"] = true,
											["callsign"] = "ARC",
											["system"] = 4,
											["channel"] = 46,
											["modeChannel"] = "X",
											["bearing"] = true,
											["frequency"] = 1133000000,
										}, -- end of ["params"]
									}, -- end of ["action"]
								}, -- end of ["params"]
							}, -- end of [2]
						}, -- end of ["tasks"]
					}, -- end of ["params"]
				}, -- end of ["task"]
				["type"] = "TakeOffParkingHot",
				["ETA"] = 2,
				["ETA_locked"] = true,
				["y"] = 646373.17498617,
				["x"] = -281607.28417614,
				["name"] = "DictKey_WptName_779",
				["formation_template"] = "",
				["airdromeId"] = 23,
				["speed_locked"] = true,
			}, -- end of [1]
			[2] = 
			{
				["alt"] = 4695.1392,
				["action"] = "Turning Point",
				["alt_type"] = "BARO",
				["speed"] = 172.5,
				["task"] = 
				{
					["id"] = "ComboTask",
					["params"] = 
					{
						["tasks"] = 
						{
							[1] = 
							{
								["number"] = 1,
								["auto"] = false,
								["id"] = "WrappedAction",
								["enabled"] = true,
								["params"] = 
								{
									["action"] = 
									{
										["id"] = "Option",
										["params"] = 
										{
											["value"] = 2,
											["name"] = 1,
										}, -- end of ["params"]
									}, -- end of ["action"]
								}, -- end of ["params"]
							}, -- end of [1]
							[2] = 
							{
								["number"] = 2,
								["auto"] = false,
								["id"] = "Orbit",
								["enabled"] = true,
								["params"] = 
								{
									["speedEdited"] = true,
									["pattern"] = "Race-Track",
									["speed"] = 179.86111111111,
									["altitude"] = 4695.1392,
									["altitudeEdited"] = true,
								}, -- end of ["params"]
							}, -- end of [2]
						}, -- end of ["tasks"]
					}, -- end of ["params"]
				}, -- end of ["task"]
				["type"] = "Turning Point",
				["ETA"] = 230.38148524446,
				["ETA_locked"] = false,
				["y"] = 671537.48999999,
				["x"] = -311918.78028572,
				["name"] = "DictKey_WptName_781",
				["formation_template"] = "",
				["speed_locked"] = true,
			}, -- end of [2]
			[3] = 
			{
				["alt"] = 4695.1392,
				["action"] = "Turning Point",
				["alt_type"] = "BARO",
				["speed"] = 172.5,
				["task"] = 
				{
					["id"] = "ComboTask",
					["params"] = 
					{
						["tasks"] = 
						{
						}, -- end of ["tasks"]
					}, -- end of ["params"]
				}, -- end of ["task"]
				["type"] = "Turning Point",
				["ETA"] = 449.26136315304,
				["ETA_locked"] = false,
				["y"] = 709167.80999999,
				["x"] = -308831.16428572,
				["name"] = "DictKey_WptName_782",
				["formation_template"] = "",
				["speed_locked"] = true,
			}, -- end of [3]
			[4] = 
			{
				["alt"] = 5000,
				["action"] = "Turning Point",
				["alt_type"] = "BARO",
				["speed"] = 172.5,
				["task"] = 
				{
					["id"] = "ComboTask",
					["params"] = 
					{
						["tasks"] = 
						{
						}, -- end of ["tasks"]
					}, -- end of ["params"]
				}, -- end of ["task"]
				["type"] = "Turning Point",
				["ETA"] = 771.98917953606,
				["ETA_locked"] = false,
				["y"] = 654142.30771426,
				["x"] = -295125.40228571,
				["name"] = "DictKey_WptName_865",
				["formation_template"] = "",
				["speed_locked"] = true,
			}, -- end of [4]
			[5] = 
			{
				["alt"] = 1500,
				["action"] = "Turning Point",
				["alt_type"] = "BARO",
				["speed"] = 172.5,
				["task"] = 
				{
					["id"] = "ComboTask",
					["params"] = 
					{
						["tasks"] = 
						{
						}, -- end of ["tasks"]
					}, -- end of ["params"]
				}, -- end of ["task"]
				["type"] = "Turning Point",
				["ETA"] = 1437.0107007709,
				["ETA_locked"] = false,
				["y"] = 621389.82414286,
				["x"] = -279838.84167857,
				["name"] = "DictKey_WptName_783",
				["formation_template"] = "",
				["speed_locked"] = true,
			}, -- end of [5]
			[6] = 
			{
				["alt"] = 13,
				["action"] = "Landing",
				["alt_type"] = "BARO",
				["speed"] = 138.88888888889,
				["task"] = 
				{
					["id"] = "ComboTask",
					["params"] = 
					{
						["tasks"] = 
						{
						}, -- end of ["tasks"]
					}, -- end of ["params"]
				}, -- end of ["task"]
				["type"] = "Land",
				["ETA"] = 1623.9406976963,
				["ETA_locked"] = false,
				["y"] = 647279.46875,
				["x"] = -281782.46875,
				["name"] = "DictKey_WptName_784",
				["formation_template"] = "",
				["airdromeId"] = 23,
				["speed_locked"] = true,
			}, -- end of [6]
		}, -- end of ["points"]
	}, -- end of ["route"]

	["units"] = 
	{
		[1] = 
		{
			["alt"] = 13,
			["alt_type"] = "BARO",
			["livery_id"] = "default",
			["skill"] = "Excellent",
			["parking"] = 2,
			["speed"] = 138.88888888889,
			["type"] = "KC130",
			["parking_id"] = "01",
			["x"] = -281607.28417614,
			["name"] = "Arco 1-1",
			["payload"] = 
			{
				["pylons"] = 
				{
				}, -- end of ["pylons"]
				["fuel"] = 20830,
				["flare"] = 60,
				["chaff"] = 120,
				["gun"] = 100,
			}, -- end of ["payload"]
			["y"] = 646373.17498617,
			["heading"] = 2.4487120548689,
			["callsign"] = 
			{
				[1] = 2,
				[2] = 1,
				[3] = 1,
				["name"] = "Arco11",
			}, -- end of ["callsign"]
			["onboard_num"] = "001",
		}, -- end of [1]
	}, -- end of ["units"]
	
	}},timer.getTime()+1)


end

function msn.respawnDarkstar()

	if msn.missionPoints >= 1000 then
		msn.mpUpdate(-1000, true)
		msn.out('Another AWACS is on the way!',5)
		mist.respawnGroup('Darkstar', true)
		mist.respawnGroup('Darkstar Escort Group', true)
	else
		msn.out('Insufficient mission points. Required: 1000, Available: ' .. msn.missionPoints,5)
	end
end


function msn.respawnAIUzi1()

	local groupName = 'Uzi 1'
	if Group.getByName(groupName) and Group.getByName(groupName):getSize() > 0 then
		msn.out(groupName .. ' is already active',5)
		return
	end
	if msn.missionPoints < 300 then
		msn.out('Insufficient mission points. Required: 300, Available: ' .. msn.missionPoints,5)
		return
	end
	
	
	msn.mpUpdate(-300, true)
	msn.out('Uzi 1 is on the way!',5)
	mist.scheduleFunction(mist.dynAdd,{{country = 'USA', category = 'AIRPLANE',


		["task"] = "CAS",
		["taskSelected"] = true,
		["y"] = 646733.0625,
		["x"] = -281504.625,
		["name"] = "Uzi 1",
		["start_time"] = 0,
		["communication"] = true,
		["modulation"] = 0,
		["frequency"] = 254,
		["route"] = 
		{
			["routeRelativeTOT"] = true,
			["points"] = 
			{
				[1] = 
				{
					["alt"] = 13,
					["action"] = "From Parking Area Hot",
					["alt_type"] = "BARO",
					["speed"] = 138.88888888889,
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
								[1] = 
								{
									["enabled"] = true,
									["key"] = "CAS",
									["id"] = "EngageTargets",
									["number"] = 1,
									["auto"] = true,
									["params"] = 
									{
										["targetTypes"] = 
										{
											[1] = "Ground vehicles",
										}, -- end of ["targetTypes"]
										["maxDist"] = 10000,
										["priority"] = 0,
									}, -- end of ["params"]
								}, -- end of [6]
								[2] = 
								{
									["enabled"] = true,
									["auto"] = false,
									["id"] = "WrappedAction",
									["number"] = 2,
									["params"] = 
									{
										["action"] = 
										{
											["id"] = "Option",
											["params"] = 
											{
												["value"] = 2, --EVADE_FIRE
												["name"] = 1, --REACTION_ON_THREAT 
											}, -- end of ["params"]
										}, -- end of ["action"]
									}, -- end of ["params"]
								}, -- end of [1]
								[3] = 
								{
									["enabled"] = true,
									["auto"] = false,
									["id"] = "WrappedAction",
									["number"] = 3,
									["params"] = 
									{
										["action"] = 
										{
											["id"] = "Option",
											["params"] = 
											{
												["value"] = true,
												["name"] = 6, --RTB_ON_BINGO  
											}, -- end of ["params"]
										}, -- end of ["action"]
									}, -- end of ["params"]
								}, -- end of [2]
								[4] = 
								{
									["enabled"] = true,
									["auto"] = false,
									["id"] = "WrappedAction",
									["number"] = 4,
									["params"] = 
									{
										["action"] = 
										{
											["id"] = "Option",
											["params"] = 
											{
												["value"] = 0, --NO WEAPON
												["name"] = 10, --RTB_ON_OUT_OF_AMMO
											}, -- end of ["params"]
										}, -- end of ["action"]
									}, -- end of ["params"]
								}, -- end of [3]
								[5] = 
								{
									["enabled"] = true,
									["auto"] = false,
									["id"] = "WrappedAction",
									["number"] = 5,
									["params"] = 
									{
										["action"] = 
										{
											["id"] = "Option",
											["params"] = 
											{
												["value"] = true,
												["name"] = 19, --PROHIBIT_WP_PASS_REPORT
											}, -- end of ["params"]
										}, -- end of ["action"]
									}, -- end of ["params"]
								}, -- end of [4]
								[6] = 
								{
									["enabled"] = true,
									["auto"] = false,
									["id"] = "WrappedAction",
									["number"] = 6,
									["params"] = 
									{
										["action"] = 
										{
											["id"] = "Option",
											["params"] = 
											{
												["value"] = true,
												["name"] = 15, --PROHIBIT_JETT
											}, -- end of ["params"]
										}, -- end of ["action"]
									}, -- end of ["params"]
								}, -- end of [5]
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["type"] = "TakeOffParkingHot",
					["ETA"] = 0,
					["ETA_locked"] = true,
					["y"] = 646179.875,
					["x"] = -281398.75,
					["name"] = "DictKey_WptName_1259",
					["formation_template"] = "",
					["airdromeId"] = 23,
					["speed_locked"] = true,
				}, -- end of [1]
				[2] = 
				{
					["alt"] = 495.2,
					["action"] = "Fly Over Point",
					["alt_type"] = "BARO",
					["speed"] = 272.36111111111,
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["type"] = "Turning Point",
					["ETA"] = 123.55744146509,
					["ETA_locked"] = false,
					["y"] = 679600.5588571,
					["x"] = -285339.72514285,
					["name"] = "DictKey_WptName_1260",
					["formation_template"] = "",
					["speed_locked"] = true,
				}, -- end of [2]
				[3] = 
				{
					["alt"] = 548.64,
					["action"] = "Turning Point",
					["alt_type"] = "BARO",
					["speed"] = 179.86111111111,
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["type"] = "Turning Point",
					["ETA"] = 151.13564208442,
					["ETA_locked"] = false,
					["y"] = 684348.7308571,
					["x"] = -283904.83799999,
					["name"] = "DictKey_WptName_1261",
					["formation_template"] = "",
					["speed_locked"] = true,
				}, -- end of [3]
				[4] = 
				{
					["alt"] = 548.64,
					["action"] = "Turning Point",
					["alt_type"] = "BARO",
					["speed"] = 179.86111111111,
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["type"] = "Turning Point",
					["ETA"] = 257.14130631566,
					["ETA_locked"] = false,
					["y"] = 699688.9788571,
					["x"] = -272582.27399999,
					["name"] = "DictKey_WptName_1262",
					["formation_template"] = "",
					["speed_locked"] = true,
				}, -- end of [4]
				[5] = 
				{
					["alt"] = 548.64,
					["action"] = "Turning Point",
					["alt_type"] = "BARO",
					["speed"] = 179.86111111111,
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["type"] = "Turning Point",
					["ETA"] = 331.72466514422,
					["ETA_locked"] = false,
					["y"] = 700054.2228571,
					["x"] = -285991.94657142,
					["name"] = "DictKey_WptName_1263",
					["formation_template"] = "",
					["speed_locked"] = true,
				}, -- end of [5]
				[6] = 
				{
					["alt"] = 548.64,
					["action"] = "Turning Point",
					["alt_type"] = "BARO",
					["speed"] = 179.86111111111,
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["type"] = "Turning Point",
					["ETA"] = 380.03851551278,
					["ETA_locked"] = false,
					["y"] = 691470.9888571,
					["x"] = -287348.56714285,
					["name"] = "DictKey_WptName_1264",
					["formation_template"] = "",
					["speed_locked"] = true,
				}, -- end of [6]
				[7] = 
				{
					["alt"] = 548.64,
					["action"] = "Turning Point",
					["alt_type"] = "BARO",
					["speed"] = 179.86111111111,
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["type"] = "Turning Point",
					["ETA"] = 450.2133133215,
					["ETA_locked"] = false,
					["y"] = 703259.73971425,
					["x"] = -282839.34371428,
					["name"] = "DictKey_WptName_1270",
					["formation_template"] = "",
					["speed_locked"] = true,
				}, -- end of [7]
				[8] = 
				{
					["alt"] = 548.64,
					["action"] = "Turning Point",
					["alt_type"] = "BARO",
					["speed"] = 179.86111111111,
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["type"] = "Turning Point",
					["ETA"] = 552.00323257764,
					["ETA_locked"] = false,
					["y"] = 688183.7928571,
					["x"] = -272451.82971428,
					["name"] = "DictKey_WptName_1265",
					["formation_template"] = "",
					["speed_locked"] = true,
				}, -- end of [8]
				[9] = 
				{
					["alt"] = 548.64,
					["action"] = "Turning Point",
					["alt_type"] = "BARO",
					["speed"] = 179.86111111111,
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["type"] = "Turning Point",
					["ETA"] = 615.64449555101,
					["ETA_locked"] = false,
					["y"] = 699375.91257138,
					["x"] = -274852.00457142,
					["name"] = "DictKey_WptName_1266",
					["formation_template"] = "",
					["speed_locked"] = true,
				}, -- end of [9]
				[10] = 
				{
					["alt"] = 548.64,
					["action"] = "Turning Point",
					["alt_type"] = "BARO",
					["speed"] = 179.86111111111,
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["type"] = "Turning Point",
					["ETA"] = 688.83484241942,
					["ETA_locked"] = false,
					["y"] = 696453.96057138,
					["x"] = -287687.7222857,
					["name"] = "DictKey_WptName_1269",
					["formation_template"] = "",
					["speed_locked"] = true,
				}, -- end of [10]
				[11] = 
				{
					["alt"] = 548.64,
					["action"] = "Turning Point",
					["alt_type"] = "BARO",
					["speed"] = 272.36111111111,
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
								[1] = 
								{
									["number"] = 1,
									["auto"] = false,
									["id"] = "WrappedAction",
									["enabled"] = true,
									["params"] = 
									{
										["action"] = 
										{
											["id"] = "SwitchWaypoint",
											["params"] = 
											{
												["goToWaypointIndex"] = 3,
												["fromWaypointIndex"] = 10,
											}, -- end of ["params"]
										}, -- end of ["action"]
									}, -- end of ["params"]
								}, -- end of [1]
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["type"] = "Turning Point",
					["ETA"] = 725.54667573526,
					["ETA_locked"] = false,
					["y"] = 694966.89571424,
					["x"] = -277800.04542856,
					["name"] = "DictKey_WptName_1267",
					["formation_template"] = "",
					["speed_locked"] = true,
				}, -- end of [11]
				[12] = 
				{
					["alt"] = 13,
					["action"] = "Landing",
					["alt_type"] = "BARO",
					["speed"] = 138.88888888889,
					["task"] = 
					{
						["id"] = "ComboTask",
						["params"] = 
						{
							["tasks"] = 
							{
							}, -- end of ["tasks"]
						}, -- end of ["params"]
					}, -- end of ["task"]
					["type"] = "Land",
					["ETA"] = 876.18752685326,
					["ETA_locked"] = false,
					["y"] = 647279.46875,
					["x"] = -281782.46875,
					["name"] = "DictKey_WptName_1268",
					["formation_template"] = "",
					["airdromeId"] = 23,
					["speed_locked"] = true,
				}, -- end of [12]
			}, -- end of ["points"]
		}, -- end of ["route"]
		["hidden"] = false,
		["units"] = 
		{
			[1] = 
			{
				["alt"] = 13,
				["hardpoint_racks"] = true,
				["alt_type"] = "BARO",
				["livery_id"] = "field camo scheme #1 (native)01",
				["skill"] = "Random",
				["parking"] = 23,
				["speed"] = 272.36111111111,
				["type"] = "Su-25",
				["parking_id"] = "29",
				["x"] = -281504.625,
				["name"] = "Uzi 1-1",
				["payload"] = 
				{
					["pylons"] = 
					{
						[1] = 
						{
							["CLSID"] = "{682A481F-0CB5-4693-A382-D00DD4A156D7}",
						}, -- end of [1]
						[2] = 
						{
							["CLSID"] = "{F72F47E5-C83A-4B85-96ED-D3E46671EE9A}",
						}, -- end of [2]
						[3] = 
						{
							["CLSID"] = "{79D73885-0801-45a9-917F-C90FE1CE3DFC}",
						}, -- end of [3]
						[4] = 
						{
							["CLSID"] = "{79D73885-0801-45a9-917F-C90FE1CE3DFC}",
						}, -- end of [4]
						[5] = 
						{
							["CLSID"] = "{FC56DF80-9B09-44C5-8976-DCFAFF219062}",
						}, -- end of [5]
						[6] = 
						{
							["CLSID"] = "{FC56DF80-9B09-44C5-8976-DCFAFF219062}",
						}, -- end of [6]
						[7] = 
						{
							["CLSID"] = "{79D73885-0801-45a9-917F-C90FE1CE3DFC}",
						}, -- end of [7]
						[8] = 
						{
							["CLSID"] = "{79D73885-0801-45a9-917F-C90FE1CE3DFC}",
						}, -- end of [8]
						[9] = 
						{
							["CLSID"] = "{F72F47E5-C83A-4B85-96ED-D3E46671EE9A}",
						}, -- end of [9]
						[10] = 
						{
							["CLSID"] = "{682A481F-0CB5-4693-A382-D00DD4A156D7}",
						}, -- end of [10]
					}, -- end of ["pylons"]
					["fuel"] = "2835",
					["flare"] = 128,
					["chaff"] = 128,
					["gun"] = 100,
				}, -- end of ["payload"]
				["y"] = 646733.0625,
				["heading"] = 1.8857484313557,
				["callsign"] = 
				{
					[1] = 3,
					[2] = 1,
					[3] = 1,
					["name"] = "Uzi11",
				}, -- end of ["callsign"]
				["onboard_num"] = "010",
			}, -- end of [1]
		}, -- end of ["units"]
		
	}},timer.getTime()+1)

	
	
	
	
end

function msn.respawnAISpringfield9_F5E()
	
	local groupName = 'Springfield 9'
	if Group.getByName(groupName) and Group.getByName(groupName):getSize() > 0 then
		msn.out(groupName .. ' is already active',5)
		return
	end
	
	if msn.missionPoints < 500 then
		msn.out('Insufficient mission points. Required: 500, Available: ' .. msn.missionPoints,5)
		return
	end
	
	msn.mpUpdate(-500, true)
	msn.out('Springfield 9 is on the way!',5)
	
	mist.scheduleFunction(mist.dynAdd,{{country = 'USA', category = 'AIRPLANE',

			["tasks"] = 
			{
			}, -- end of ["tasks"]
			["task"] = "Fighter Sweep",
			["taskSelected"] = true,
			["y"] = 646756.25,
			["x"] = -281191.59375,
			["name"] = "Springfield 9",
			["communication"] = true,
			["modulation"] = 0,
			["frequency"] = 254,
			["route"] = 
			{
				["routeRelativeTOT"] = true,
				["points"] = 
				{
					[1] = 
					{
						["alt"] = 13,
						["action"] = "From Parking Area Hot",
						["alt_type"] = "BARO",
						["speed"] = 138.88888888889,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
									[1] = 
									{
										["enabled"] = true,
										["auto"] = false,
										["id"] = "EngageTargets",
										["number"] = 1,
										["params"] = 
										{
											["targetTypes"] = 
											{
												[1] = "Air",
											}, -- end of ["targetTypes"]
											["maxDistEnabled"] = true,
											["priority"] = 0,
											["value"] = "Air;",
											["maxDist"] = 37000,
										}, -- end of ["params"]
									}, -- end of [1]
									[2] = 
									{
										["number"] = 2,
										["auto"] = false,
										["id"] = "WrappedAction",
										["enabled"] = true,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = 2,
													["name"] = 0,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [3]
									[3] = 
									{
										["number"] = 3,
										["auto"] = false,
										["id"] = "WrappedAction",
										["enabled"] = true,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = 2,
													["name"] = 1,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [4]
									[4] = 
									{
										["number"] = 4,
										["auto"] = false,
										["id"] = "WrappedAction",
										["enabled"] = true,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = 2,
													["name"] = 3,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [5]
									[5] = 
									{
										["number"] = 5,
										["auto"] = false,
										["id"] = "WrappedAction",
										["enabled"] = true,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = true,
													["name"] = 6,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [6]
									[6] = 
									{
										["number"] = 6,
										["auto"] = false,
										["id"] = "WrappedAction",
										["enabled"] = true,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = 0,
													["name"] = 10,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [7]
									[7] = 
									{
										["number"] = 7,
										["auto"] = false,
										["id"] = "WrappedAction",
										["enabled"] = true,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = true,
													["name"] = 17,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [8]
									[8] = 
									{
										["number"] = 8,
										["auto"] = false,
										["id"] = "WrappedAction",
										["enabled"] = true,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = true,
													["name"] = 19,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [9]
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "TakeOffParkingHot",
						["ETA_locked"] = true,
						["y"] = 646756.25,
						["x"] = -281191.59375,
						["name"] = "DictKey_WptName_1113",
						
						["airdromeId"] = 23,
						["speed_locked"] = true,
					}, -- end of [1]
					[2] = 
					{
						["alt"] = 2438.4,
						["action"] = "Turning Point",
						["alt_type"] = "BARO",
						["speed"] = 205,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
									[1] = 
									{
										["enabled"] = true,
										["auto"] = false,
										["id"] = "Orbit",
										["number"] = 1,
										["params"] = 
										{
											["altitude"] = 2438.4,
											["pattern"] = "Circle",
											["speed"] = 130,
											["speedEdited"] = true,
										}, -- end of ["params"]
									}, -- end of [1]
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "Turning Point",
						["ETA_locked"] = false,
						["y"] = 685933.83896429,
						["x"] = -286414.246875,
						["name"] = "DictKey_WptName_1114",
						
						["speed_locked"] = true,
					}, -- end of [2]
					[3] = 
					{
						["alt"] = 457.2,
						["action"] = "Fly Over Point",
						["alt_type"] = "BARO",
						["speed"] = 484.08333333333,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "Turning Point",
						["ETA_locked"] = false,
						["y"] = 647310.92753572,
						["x"] = -279542.11030357,
						["name"] = "DictKey_WptName_1115",
						
						["airdromeId"] = 23,
						["speed_locked"] = true,
					}, -- end of [3]
					[4] = 
					{
						["alt"] = 13,
						["action"] = "Landing",
						["alt_type"] = "BARO",
						["speed"] = 138.88888888889,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "Land",
						["ETA_locked"] = false,
						["y"] = 647279.46875,
						["x"] = -281782.46875,
						["name"] = "DictKey_WptName_1116",
						
						["airdromeId"] = 23,
						["speed_locked"] = true,
					}, -- end of [4]
				}, -- end of ["points"]
			}, -- end of ["route"]
			["units"] = 
			{
				[1] = 
				{
					["alt"] = 13,
					["hardpoint_racks"] = true,
					["alt_type"] = "BARO",
					["livery_id"] = "US Aggressor VFC-111 105 WWII B",
					["skill"] = "Random",
					["parking"] = 10,
					["speed"] = 138.88888888889,
					["AddPropAircraft"] = 
					{
					}, -- end of ["AddPropAircraft"]
					["type"] = "F-5E-3",
					["parking_id"] = "18",
					["x"] = -281191.59375,
					["name"] = "Springfield 9-1",
					["payload"] = 
					{
						["pylons"] = 
						{
							[1] = 
							{
								["CLSID"] = "{AIM-9P5}",
							}, -- end of [1]
							[3] = 
							{
								["CLSID"] = "{PTB-150GAL}",
							}, -- end of [3]
							[4] = 
							{
								["CLSID"] = "{PTB-150GAL}",
							}, -- end of [4]
							[5] = 
							{
								["CLSID"] = "{PTB-150GAL}",
							}, -- end of [5]
							[7] = 
							{
								["CLSID"] = "{AIM-9P5}",
							}, -- end of [7]
						}, -- end of ["pylons"]
						["fuel"] = 2046,
						["flare"] = 15,
						["ammo_type"] = 1,
						["chaff"] = 30,
						["gun"] = 100,
					}, -- end of ["payload"]
					["y"] = 646756.25,
					["heading"] = 1.7033221429596,
					["callsign"] = 
					{
						[1] = 2,
						[2] = 9,
						[3] = 1,
						["name"] = "Springfield91",
					}, -- end of ["callsign"]
					["onboard_num"] = "057",
				}, -- end of [1]
			}, -- end of ["units"]
			
	}},timer.getTime()+1)

	
end

function msn.respawnAISpringfield9_F14()
	
	local groupName = 'Springfield 9'
	if Group.getByName(groupName) and Group.getByName(groupName):getSize() > 0 then
		msn.out(groupName .. ' is already active',5)
		return
	end
	
	if msn.missionPoints < 1000 then
		msn.out('Insufficient mission points. Required: 1000, Available: ' .. msn.missionPoints,5)
		return
	end
	
	msn.mpUpdate(-1000, true)
	msn.out('Springfield 9 is on the way!',5)
	
	mist.scheduleFunction(mist.dynAdd,{{country = 'USA', category = 'AIRPLANE',

			["tasks"] = 
			{
			}, -- end of ["tasks"]
			["task"] = "Fighter Sweep",
			["taskSelected"] = true,
			["y"] = 646756.25,
			["x"] = -281191.59375,
			["name"] = "Springfield 9",
			["communication"] = true,
			["modulation"] = 0,
			["frequency"] = 254,
			["route"] = 
			{
				["routeRelativeTOT"] = true,
				["points"] = 
				{
					[1] = 
					{
						["alt"] = 13,
						["action"] = "From Parking Area Hot",
						["alt_type"] = "BARO",
						["speed"] = 138.88888888889,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
									[1] = 
									{
										["enabled"] = true,
										["auto"] = false,
										["id"] = "EngageTargets",
										["number"] = 1,
										["params"] = 
										{
											["targetTypes"] = 
											{
												[1] = "Air",
											}, -- end of ["targetTypes"]
											["maxDistEnabled"] = true,
											["priority"] = 0,
											["value"] = "Air;",
											["maxDist"] = 37000,
										}, -- end of ["params"]
									}, -- end of [1]
									[2] = 
									{
										["number"] = 2,
										["auto"] = false,
										["id"] = "WrappedAction",
										["enabled"] = true,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = 2,
													["name"] = 0,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [3]
									[3] = 
									{
										["number"] = 3,
										["auto"] = false,
										["id"] = "WrappedAction",
										["enabled"] = true,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = 2,
													["name"] = 1,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [4]
									[4] = 
									{
										["number"] = 4,
										["auto"] = false,
										["id"] = "WrappedAction",
										["enabled"] = true,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = 2,
													["name"] = 3,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [5]
									[5] = 
									{
										["number"] = 5,
										["auto"] = false,
										["id"] = "WrappedAction",
										["enabled"] = true,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = true,
													["name"] = 6,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [6]
									[6] = 
									{
										["number"] = 6,
										["auto"] = false,
										["id"] = "WrappedAction",
										["enabled"] = true,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = 0,
													["name"] = 10,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [7]
									[7] = 
									{
										["number"] = 7,
										["auto"] = false,
										["id"] = "WrappedAction",
										["enabled"] = true,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = true,
													["name"] = 17,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [8]
									[8] = 
									{
										["number"] = 8,
										["auto"] = false,
										["id"] = "WrappedAction",
										["enabled"] = true,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = true,
													["name"] = 19,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [9]
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "TakeOffParkingHot",
						["ETA_locked"] = true,
						["y"] = 646756.25,
						["x"] = -281191.59375,
						["name"] = "DictKey_WptName_1113",
						
						["airdromeId"] = 23,
						["speed_locked"] = true,
					}, -- end of [1]
					[2] = 
					{
						["alt"] = 2438.4,
						["action"] = "Turning Point",
						["alt_type"] = "BARO",
						["speed"] = 205,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
									[1] = 
									{
										["enabled"] = true,
										["auto"] = false,
										["id"] = "Orbit",
										["number"] = 1,
										["params"] = 
										{
											["altitude"] = 2438.4,
											["pattern"] = "Circle",
											["speed"] = 130,
											["speedEdited"] = true,
										}, -- end of ["params"]
									}, -- end of [1]
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "Turning Point",
						["ETA_locked"] = false,
						["y"] = 685933.83896429,
						["x"] = -286414.246875,
						["name"] = "DictKey_WptName_1114",
						
						["speed_locked"] = true,
					}, -- end of [2]
					[3] = 
					{
						["alt"] = 457.2,
						["action"] = "Fly Over Point",
						["alt_type"] = "BARO",
						["speed"] = 484.08333333333,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "Turning Point",
						["ETA_locked"] = false,
						["y"] = 647310.92753572,
						["x"] = -279542.11030357,
						["name"] = "DictKey_WptName_1115",
						
						["airdromeId"] = 23,
						["speed_locked"] = true,
					}, -- end of [3]
					[4] = 
					{
						["alt"] = 13,
						["action"] = "Landing",
						["alt_type"] = "BARO",
						["speed"] = 138.88888888889,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "Land",
						["ETA_locked"] = false,
						["y"] = 647279.46875,
						["x"] = -281782.46875,
						["name"] = "DictKey_WptName_1116",
						
						["airdromeId"] = 23,
						["speed_locked"] = true,
					}, -- end of [4]
				}, -- end of ["points"]
			}, -- end of ["route"]
			["units"] = 
			{
				[1] = 
				{
					["alt"] = 13,
					["hardpoint_racks"] = true,
					["alt_type"] = "BARO",
					["livery_id"] = "black demo scheme",
					["skill"] = "Random",
					["parking"] = 10,
					["speed"] = 138.88888888889,
					["AddPropAircraft"] = 
					{
					}, -- end of ["AddPropAircraft"]
					["type"] = "F-14A",
					["parking_id"] = "18",
					["x"] = -281191.59375,
					["name"] = "Springfield 9-1",
					["payload"] = 
					{
						["pylons"] = 
						{
							[1] = 
							{
								["CLSID"] = "{6CEB49FC-DED8-4DED-B053-E1F033FF72D3}",
							}, -- end of [1]
							[2] = 
							{
								["CLSID"] = "{8D399DDA-FF81-4F14-904D-099B34FE7918}",
							}, -- end of [2]
							[4] = 
							{
								["CLSID"] = "{7575BA0B-7294-4844-857B-031A144B2595}",
							}, -- end of [4]
							[5] = 
							{
								["CLSID"] = "{7575BA0B-7294-4844-857B-031A144B2595}",
							}, -- end of [5]
							[8] = 
							{
								["CLSID"] = "{7575BA0B-7294-4844-857B-031A144B2595}",
							}, -- end of [8]
							[11] = 
							{
								["CLSID"] = "{8D399DDA-FF81-4F14-904D-099B34FE7918}",
							}, -- end of [11]
							[9] = 
							{
								["CLSID"] = "{7575BA0B-7294-4844-857B-031A144B2595}",
							}, -- end of [9]
							[12] = 
							{
								["CLSID"] = "{6CEB49FC-DED8-4DED-B053-E1F033FF72D3}",
							}, -- end of [12]
						}, -- end of ["pylons"]
						["fuel"] = 7348,
						["flare"] = 15,
						["chaff"] = 30,
						["gun"] = 100,
					}, -- end of ["payload"]
					["y"] = 646756.25,
					["heading"] = 1.7033221429596,
					["callsign"] = 
					{
						[1] = 2,
						[2] = 9,
						[3] = 1,
						["name"] = "Springfield91",
					}, -- end of ["callsign"]
					["onboard_num"] = "057",
				}, -- end of [1]
			}, -- end of ["units"]
			
	}},timer.getTime()+1)

	
end




function msn.cas_GroundAssaultSuccess()

	mist.removeFunction(msn.groupAliveCheckTaskID)

	if msn.groundAssaultBuildingCounter > 0 then
	
		local warehouse = StaticObject.getByName('WareHouse #00' .. msn.groundAssaultBuildingCounter)
		if warehouse then
			local warehousePos = warehouse:getPosition().p
			trigger.action.explosion(warehousePos, 200)
		end
		
		msn.groundAssaultBuildingCounter = msn.groundAssaultBuildingCounter - 1
		
		mist.scheduleFunction(msn.cas_GroundAssaultSuccessRemoveGroup,{},timer.getTime()+7)
		
		mist.scheduleFunction(msn.warehouseRemoval,{warehouseName},timer.getTime()+30)
		
		
		
	end


end

function msn.cas_GroundAssaultSuccessRemoveGroup()


		targetGroup = Group.getByName('Russian Ground Assault Group')
		targetGroup:destroy()
		
		mist.scheduleFunction(mist.respawnGroup,{'WH Defense Group', true},timer.getTime()+40)
		
		if msn.cas_SmokeResetTaskID ~= 'none' then
			mist.removeFunction(msn.cas_SmokeResetTaskID)
		end
	

		
		missionCommands.removeItem({'Tasking', 'Ground', 'Target information'})
		msn.strTargetInfo = nil
		msn.strTargetInfoSmoke = nil
		missionCommands.addCommand('CAS check in', _taskingsGroundPath, msn.cas_CreateTasking)
		
		msn.out('Current CAS tasking failed! Assaulting ground force reached the depot! You may now request a new CAS tasking.', 5)


end

function msn.cap_CreateTasking()

	missionCommands.removeItem({'Tasking', 'Air', 'CAP check in'})
	msn.out('Roger CAP on station, push 124 AM for Darkstar',5)

	local taskType = mist.random(2)
	
	if taskType == 1 then
		msn.cap_SpawnFastAirAttackGroup()
	elseif taskType == 2 then
		msn.cap_SpawnAirAttackGroup()
	--elseif taskType == 3 then
		--msn.cap_SpawnEnemyTransport()
	end

	
end


function msn.cap_SpawnFastAirAttackGroup()

		local randomSpawnZoneNumber = mist.random(5)

		msn.funcNextRedGroupNumber()
		msn.funcNextRedUnitNumber()
		
		local escortGroupName = msn.cap_SpawnFastAirAttackGroupBomber(randomSpawnZoneNumber)

		msn.funcNextRedGroupNumber()
		msn.funcNextRedUnitNumber()
		
		mist.scheduleFunction(msn.cap_SpawnFastAirAttackGroupFighter,{randomSpawnZoneNumber, escortGroupName}, timer.getTime() + 2)
		
		msn.currentCAPTargets = 2

end

function msn.cap_SpawnFastAirAttackGroupBomber(spawnZoneNumber)

				local aihuntingzone = trigger.misc.getZone('ai hunting zone')
				local spawnZone = trigger.misc.getZone('ai fighter spawn zone ' .. spawnZoneNumber)
				local spawnPoint = mist.getRandPointInCircle(spawnZone.point, spawnZone.radius)
				local targetZone = trigger.misc.getZone('Objective Zone')
				local targetPoint = mist.getRandPointInCircle(targetZone.point, 10)
				local waypoint2 = mist.getRandPointInCircle(mist.utils.zoneToVec3('ai hunting zone'),aihuntingzone.radius)
				local groupName = 'Red Bomber Group ' .. msn.currentRedGroupNumber
				local unitName = 'Red Bomber Unit ' .. msn.currentRedUnitNumber
				
					
					
					mist.scheduleFunction(mist.dynAdd,{{country = 'RUSSIA', category = 'AIRPLANE', 
						["modulation"] = 0,
						["radioSet"] = false,
						["task"] = "Ground Attack",
						["uncontrolled"] = false,
						["taskSelected"] = true,
						["hidden"] = false,
						["y"] = spawnPoint.y,
						["x"] = spawnPoint.x,
						["name"] = groupName,
						["communication"] = false,
						["frequency"] = 251,
						["route"] = 
						{
							["points"] = 
											{
												[1] = 
												{
													["alt"] = 2000,
													["type"] = "Turning Point",
													["action"] = "Turning Point",
													["alt_type"] = "BARO",													
													["y"] = spawnPoint.y,
													["x"] = spawnPoint.x,
													["speed"] = 250,
													["ETA_locked"] = true,
													["task"] = 
													{
														["id"] = "ComboTask",
														["params"] = 
														{
															["tasks"] = 
															{
																[1] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "WrappedAction",
																	["number"] = 1,
																	["params"] = 
																	{
																		["action"] = 
																		{
																			["id"] = "Option",
																			["params"] = 
																			{
																				["value"] = 2,
																				["name"] = 1,
																			}, -- end of ["params"]
																		}, -- end of ["action"]
																	}, -- end of ["params"]
																}, -- end of [1]
																[2] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "WrappedAction",
																	["number"] = 2,
																	["params"] = 
																	{
																		["action"] = 
																		{
																			["id"] = "Option",
																			["params"] = 
																			{
																				["value"] = 2,
																				["name"] = 1,
																			}, -- end of ["params"]
																		}, -- end of ["action"]
																	}, -- end of ["params"]
																}, -- end of [2]
																[3] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "WrappedAction",
																	["number"] = 3,
																	["params"] = 
																	{
																		["action"] = 
																		{
																			["id"] = "Option",
																			["params"] = 
																			{
																				["value"] = 3,
																				["name"] = 3,
																			}, -- end of ["params"]
																		}, -- end of ["action"]
																	}, -- end of ["params"]
																}, -- end of [3]
															}, -- end of ["tasks"]
														}, -- end of ["params"]
													}, -- end of ["task"]
													["speed_locked"] = true,
												}, -- end of [1]
												[2] = 
												{
													["alt"] = 1500,
													["type"] = "Turning Point",
													["action"] = "Turning Point",
													["alt_type"] = "BARO",													
													["y"] = targetPoint.y,
													["x"] = targetPoint.x,
													["speed"] = 260,
													["ETA_locked"] = false,
													["speed_locked"] = true,
													["task"] = 
													{
														["id"] = "ComboTask",
														["params"] = 
														{
															["tasks"] = 
															{
																[1] = 
																{
																	["number"] = 1,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["enabled"] = true,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "Auto",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 688975.42857143,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 1073741822,
																		["x"] = -283250.57142856,
																	}, -- end of ["params"]
																}, -- end of [1]
																[2] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["number"] = 2,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "Auto",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 689030.85714286,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 1073741822,
																		["x"] = -283272.57142856,
																	}, -- end of ["params"]
																}, -- end of [2]
																[3] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["number"] = 3,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "Auto",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 689004.85714286,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 1073741822,
																		["x"] = -283335.99999999,
																	}, -- end of ["params"]
																}, -- end of [3]
																[4] = 
																{
																	["number"] = 4,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["enabled"] = true,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "Auto",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 688945.42857144,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 1073741822,
																		["x"] = -283311.99999999,
																	}, -- end of ["params"]
																}, -- end of [4]
																[5] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["number"] = 5,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "Auto",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 688977.14285715,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 1073741822,
																		["x"] = -283393.99999999,
																	}, -- end of ["params"]
																}, -- end of [5]
																[6] = 
																{
																	["number"] = 6,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["enabled"] = true,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "Auto",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 688918.85714287,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 1073741822,
																		["x"] = -283369.99999999,
																	}, -- end of ["params"]
																}, -- end of [6]
																[7] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["number"] = 7,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "One",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 688948.28571429,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 30720,
																		["x"] = -283452.85714285,
																	}, -- end of ["params"]
																}, -- end of [7]
																[8] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["number"] = 8,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "One",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 688891.14285715,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 30720,
																		["x"] = -283430.28571428,
																	}, -- end of ["params"]
																}, -- end of [8]
															}, -- end of ["tasks"]
														}, -- end of ["params"]
													}, -- end of ["task"]
												}, -- end of [2]
											}, -- end of ["points"]
						}, -- end of ["route"]
						["units"] = 
						{
							[1] = 
							{
								["alt"] = 1000,
								["hardpoint_racks"] = true,
								["alt_type"] = "RADIO",
								["livery_id"] = "af standard",
								["skill"] = "Random",
								["speed"] = 250, --308.33333333333,
								["type"] = "Su-24M",
								["y"] = spawnPoint.y,
								["x"] = spawnPoint.x,
								["name"] = unitName,
								["payload"] = 
								{
									["pylons"] = 
									{
										[1] = 
										{
											["CLSID"] = "{A0648264-4BC0-4EE8-A543-D119F6BA4257}",
										}, -- end of [1]
										[2] = 
										{
											["CLSID"] = "{39821727-F6E2-45B3-B1F0-490CC8921D1E}",
										}, -- end of [2]
										[3] = 
										{
											["CLSID"] = "{BA565F89-2373-4A84-9502-A0E017D3A44A}",
										}, -- end of [3]
										[4] = 
										{
											["CLSID"] = "{39821727-F6E2-45B3-B1F0-490CC8921D1E}",
										}, -- end of [4]
										[5] = 
										{
											["CLSID"] = "{3C612111-C7AD-476E-8A8E-2485812F4E5C}",
										}, -- end of [5]
										[6] = 
										{
											["CLSID"] = "{BA565F89-2373-4A84-9502-A0E017D3A44A}",
										}, -- end of [6]
										[7] = 
										{
											["CLSID"] = "{39821727-F6E2-45B3-B1F0-490CC8921D1E}",
										}, -- end of [7]
										[8] = 
										{
											["CLSID"] = "{A0648264-4BC0-4EE8-A543-D119F6BA4257}",
										}, -- end of [8]
									}, -- end of ["pylons"]
									["fuel"] = "11700",
									["flare"] = 96,
									["chaff"] = 96,
									["gun"] = 100,
								}, -- end of ["payload"]
								["heading"] = 180,
								["callsign"] = 500+msn.currentRedUnitNumber,
								["onboard_num"] = '500',
							}, -- end of [1]
						}, -- end of ["units"]
						
						
					}},timer.getTime()+1)
					
					return groupName

end

function msn.cap_SpawnFastAirAttackGroupFighter(spawnZoneNumber, escortGroupName)

				local fighterType = 'MiG-23MLD'
				local groupName = 'Red Fighter Group ' .. msn.currentRedGroupNumber
				local unitName = 'Red Bomber Unit ' .. msn.currentRedUnitNumber
				local escortGroupID = Group.getID(Group.getByName(escortGroupName))
				local spawnZone = trigger.misc.getZone('ai fighter spawn zone ' .. spawnZoneNumber)
				local spawnPoint = mist.getRandPointInCircle(spawnZone.point, spawnZone.radius)
				local orbitZone = trigger.misc.getZone('Objective Zone')
				local orbitPoint = mist.getRandPointInCircle(orbitZone.point, 10)
				
				mist.scheduleFunction(mist.dynAdd,{{country = 'RUSSIA', category = 'AIRPLANE', --MiG-23MLD
				
					["tasks"] = 
					{
					}, -- end of ["tasks"]
					["radioSet"] = false,
					["task"] = "Fighter Sweep",
					["taskSelected"] = true,
					["y"] = spawnPoint.y,
					["x"] = spawnPoint.x,
					["name"] = groupName,
					["communication"] = false,
					["route"] = 
					{
						["points"] = {
								[1] = 
								{
									["alt"] = 8000,
									["action"] = "Fly Over Point",
									["alt_type"] = "BARO",
									["speed"] = 250,
									["type"] = "Turning Point",
									["y"] = spawnPoint.y,
									["x"] = spawnPoint.x,
									["name"] = "DictKey_WptName_12",
									["task"] = 
									{
										["id"] = "ComboTask",
										["params"] = 
										{
											["tasks"] = 
											{
												[1] = 
												{
													["enabled"] = true,
													["auto"] = true,
													["id"] = "WrappedAction",
													["number"] = 1,
													["params"] = 
													{
														["action"] = 
														{
															["id"] = "Option",
															["params"] = 
															{
																["value"] = 2,
																["name"] = 1,
															}, -- end of ["params"]
														}, -- end of ["action"]
													}, -- end of ["params"]
												}, -- end of [1]
												[2] = 
												{
													["enabled"] = true,
													["auto"] = false,
													["id"] = "WrappedAction",
													["number"] = 2,
													["params"] = 
													{
														["action"] = 
														{
															["id"] = "Option",
															["params"] = 
															{
																["value"] = true,
																["name"] = 6,
															}, -- end of ["params"]
														}, -- end of ["action"]
													}, -- end of ["params"]
												}, -- end of [2]
												[3] = 
												{
													["enabled"] = true,
													["auto"] = false,
													["id"] = "EngageTargets",
													["number"] = 3,
													["params"] = 
													{
														["targetTypes"] = 
														{
															[1] = "Fighters",
														}, -- end of ["targetTypes"]
														["maxDistEnabled"] = true,
														["priority"] = 0,
														["value"] = "Fighters;",
														["maxDist"] = 10000,
													}, -- end of ["params"]
												}, -- end of [3]
												[4] = 
												{
													["number"] = 4,
													["auto"] = false,
													["id"] = "Follow",
													["enabled"] = true,
													["params"] = 
													{
														["lastWptIndexFlagChangedManually"] = true,
														["groupId"] = escortGroupID,
														["lastWptIndex"] = 2,
														["lastWptIndexFlag"] = true,
														["pos"] = 
														{
															["y"] = 0,
															["x"] = -91.44,
															["z"] = 91.44,
														}, -- end of ["pos"]
													}, -- end of ["params"]
												}, -- end of [4]
												[5] = 
												{
													["number"] = 5,
													["auto"] = false,
													["id"] = "WrappedAction",
													["enabled"] = true,
													["params"] = 
													{
														["action"] = 
														{
															["id"] = "SwitchWaypoint",
															["params"] = 
															{
																["goToWaypointIndex"] = 2,
																["fromWaypointIndex"] = 1,
															}, -- end of ["params"]
														}, -- end of ["action"]
													}, -- end of ["params"]
												}, -- end of [5]
											}, -- end of ["tasks"]
										}, -- end of ["params"]
									}, -- end of ["task"]
									

								}, -- end of [1]
								[2] = 
								{
									["alt"] = 2500,
									["action"] = "Turning Point",
									["alt_type"] = "BARO",
									["speed"] = 138.88888888889,
									["task"] = 
									{
										["id"] = "ComboTask",
										["params"] = 
										{
											["tasks"] = 
											{
												[1] = 
												{
													["number"] = 1,
													["auto"] = false,
													["id"] = "Orbit",
													["enabled"] = true,
													["params"] = 
													{
														["altitude"] = 2500,
														["pattern"] = "Circle",
														["speed"] = 138.88888888889,
													}, -- end of ["params"]
												}, -- end of [1]
											}, -- end of ["tasks"]
										}, -- end of ["params"]
									}, -- end of ["task"]
									["type"] = "Turning Point",
									["y"] = orbitPoint.y,
									["x"] = orbitPoint.x,
									["name"] = "DictKey_WptName_32",


								}, -- end of [2]
							}, -- end of ["points"]
					}, -- end of ["route"]
					["hidden"] = false,
					["units"] = 
					{
						[1] = 
						{
							["alt"] = 8000,
							["alt_type"] = "RADIO",
							["livery_id"] = "af standard-3 (worn-out)",
							["skill"] = "Random",
							["speed"] = 230, --694.26388888889,
							["type"] = fighterType,
							["y"] = spawnPoint.y,
							["x"] = spawnPoint.x,
							["name"] = unitName,
							["heading"] = 180,
							["callsign"] = 200+msn.currentRedUnitNumber,
							["onboard_num"] = '200',
							["payload"] = 
							{
								["pylons"] = 
								{
									[2] = 
									{
										["CLSID"] = "{CCF898C9-5BC7-49A4-9D1E-C3ED3D5166A1}",
									}, -- end of [2]
									[3] = 
									{
										["CLSID"] = "{682A481F-0CB5-4693-A382-D00DD4A156D7}",
									}, -- end of [3]
									[4] = 
									{
										["CLSID"] = "{A5BAEAB7-6FAF-4236-AF72-0FD900F493F9}",
									}, -- end of [4]
									[5] = 
									{
										["CLSID"] = "{682A481F-0CB5-4693-A382-D00DD4A156D7}",
									}, -- end of [5]
									[6] = 
									{
										["CLSID"] = "{CCF898C9-5BC7-49A4-9D1E-C3ED3D5166A1}",
									}, -- end of [6]
								}, -- end of ["pylons"]
								["fuel"] = "3800",
								["flare"] = 60,
								["chaff"] = 60,
								["gun"] = 100,
							}, -- end of ["payload"]
						}, -- end of [1]
					} -- end of ["units"]
				}},timer.getTime()+3)

end

function msn.cap_SpawnAirAttackGroup()

				
				local groupName = 'Red Attack Group ' .. msn.funcNextRedGroupNumber()
				msn.currentAirAttackGroupName = groupName
				local unitName1 = 'Red Attack Unit ' .. msn.funcNextRedUnitNumber()
				local unitName2 = 'Red Attack Unit ' .. msn.funcNextRedUnitNumber()
				local unitName3 = 'Red Attack Unit ' .. msn.funcNextRedUnitNumber()
				

				local aihuntingzone = trigger.misc.getZone('ai hunting zone')
				local unitSpawnZone = trigger.misc.getZone('ai fighter spawn zone ' .. mist.random(5))
				local spawnPoint = mist.getRandPointInCircle(unitSpawnZone.point, unitSpawnZone.radius)
				local waypoint2 = mist.getRandPointInCircle(mist.utils.zoneToVec3('ai hunting zone'),aihuntingzone.radius)
				local waypoint3 = mist.getRandPointInCircle(mist.utils.zoneToVec3('ai hunting zone'),aihuntingzone.radius)

					

					
					
					mist.scheduleFunction(mist.dynAdd,{{country = 'RUSSIA', category = 'AIRPLANE', 
						["modulation"] = 0,
						["radioSet"] = false,
						["task"] = "Ground Attack",
						["uncontrolled"] = false,
						["taskSelected"] = true,
						["hidden"] = false,
						["y"] = spawnPoint.y,
						["x"] = spawnPoint.x,
						["name"] = groupName,
						["communication"] = false,
						["frequency"] = 251,
						["route"] = 
						{
							["points"] = 
											{
												[1] = 
												{
													["alt"] = 5000,
													["type"] = "Turning Point",
													["action"] = "Turning Point",
													["alt_type"] = "BARO",													
													["y"] = spawnPoint.y,
													["x"] = spawnPoint.x,
													["speed"] = 231.25,
													["ETA_locked"] = true,
													["task"] = 
													{
														["id"] = "ComboTask",
														["params"] = 
														{
															["tasks"] = 
															{
																[1] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "WrappedAction",
																	["number"] = 1,
																	["params"] = 
																	{
																		["action"] = 
																		{
																			["id"] = "Option",
																			["params"] = 
																			{
																				["value"] = 2,
																				["name"] = 1,
																			}, -- end of ["params"]
																		}, -- end of ["action"]
																	}, -- end of ["params"]
																}, -- end of [1]
																[2] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "WrappedAction",
																	["number"] = 2,
																	["params"] = 
																	{
																		["action"] = 
																		{
																			["id"] = "Option",
																			["params"] = 
																			{
																				["value"] = true,
																				["name"] = 15,
																			}, -- end of ["params"]
																		}, -- end of ["action"]
																	}, -- end of ["params"]
																}, -- end of [2]
																[3] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "WrappedAction",
																	["number"] = 3,
																	["params"] = 
																	{
																		["action"] = 
																		{
																			["id"] = "Option",
																			["params"] = 
																			{
																				["value"] = 2147485694,
																				["name"] = 10,
																			}, -- end of ["params"]
																		}, -- end of ["action"]
																	}, -- end of ["params"]
																}, -- end of [3]
																[4] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "WrappedAction",
																	["number"] = 4,
																	["params"] = 
																	{
																		["action"] = 
																		{
																			["id"] = "Option",
																			["params"] = 
																			{
																				["value"] = true,
																				["name"] = 6,
																			}, -- end of ["params"]
																		}, -- end of ["action"]
																	}, -- end of ["params"]
																}, -- end of [3]
															}, -- end of ["tasks"]
														}, -- end of ["params"]
													}, -- end of ["task"]
													["speed_locked"] = true,
												}, -- end of [1]
												[2] = 
												{
													["alt"] = 3000,
													["type"] = "Turning Point",
													["action"] = "Turning Point",
													["alt_type"] = "BARO",
													["y"] = waypoint2.y,
													["x"] = waypoint2.x,
													["speed"] = 231.25,
													["ETA_locked"] = false,
													["task"] = 
													{
														["id"] = "ComboTask",
														["params"] = 
														{
															["tasks"] = 
															{
															}, -- end of ["tasks"]
														}, -- end of ["params"]
													}, -- end of ["task"]
													["speed_locked"] = true,
												}, -- end of [2]
												[3] = 
												{
													["alt"] = 1500,
													["type"] = "Turning Point",
													["action"] = "Turning Point",
													["alt_type"] = "BARO",													
													["y"] = waypoint3.y,
													["x"] = waypoint3.x,
													["speed"] = 205.55555555556,
													["ETA_locked"] = false,
													["speed_locked"] = true,
													["task"] = 
													{
														["id"] = "ComboTask",
														["params"] = 
														{
															["tasks"] = 
															{
																[1] = 
																{
																	["number"] = 1,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["enabled"] = true,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "Auto",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 688975.42857143,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 2032,
																		["x"] = -283250.57142856,
																	}, -- end of ["params"]
																}, -- end of [1]
																[2] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["number"] = 2,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "Auto",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 689030.85714286,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 2032,
																		["x"] = -283272.57142856,
																	}, -- end of ["params"]
																}, -- end of [2]
																[3] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["number"] = 3,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "Auto",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 689004.85714286,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 2032,
																		["x"] = -283335.99999999,
																	}, -- end of ["params"]
																}, -- end of [3]
																[4] = 
																{
																	["number"] = 4,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["enabled"] = true,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "Auto",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 688945.42857144,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 2032,
																		["x"] = -283311.99999999,
																	}, -- end of ["params"]
																}, -- end of [4]
																[5] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["number"] = 5,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "Auto",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 688977.14285715,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 2032,
																		["x"] = -283393.99999999,
																	}, -- end of ["params"]
																}, -- end of [5]
																[6] = 
																{
																	["number"] = 6,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["enabled"] = true,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "Auto",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 688918.85714287,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 2032,
																		["x"] = -283369.99999999,
																	}, -- end of ["params"]
																}, -- end of [6]
																[7] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["number"] = 7,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "One",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 688948.28571429,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 2032,
																		["x"] = -283452.85714285,
																	}, -- end of ["params"]
																}, -- end of [7]
																[8] = 
																{
																	["enabled"] = true,
																	["auto"] = false,
																	["id"] = "Bombing",
																	["number"] = 8,
																	["params"] = 
																	{
																		["direction"] = 0,
																		["attackQtyLimit"] = false,
																		["attackQty"] = 1,
																		["expend"] = "One",
																		["altitude"] = 1859.28,
																		["directionEnabled"] = false,
																		["groupAttack"] = false,
																		["y"] = 688891.14285715,
																		["altitudeEnabled"] = false,
																		["weaponType"] = 2032,
																		["x"] = -283430.28571428,
																	}, -- end of ["params"]
																}, -- end of [8]
															}, -- end of ["tasks"]
														}, -- end of ["params"]
													}, -- end of ["task"]
												}, -- end of [3]
											}, -- end of ["points"]
						}, -- end of ["route"]
						["units"] = 
						{
							[1] = 
							{
								["alt"] = 5000,
								["hardpoint_racks"] = true,
								["alt_type"] = "BARO",
								["livery_id"] = "su-25t test scheme",
								["skill"] = "Random",
								["speed"] = 282.63888888889,
								["type"] = "Su-25T",
								["y"] = spawnPoint.y,
								["x"] = spawnPoint.x,
								["name"] = unitName1,
								["payload"] = 
								{
									["pylons"] = 
									{
										[1] = 
										{
											["CLSID"] = "{682A481F-0CB5-4693-A382-D00DD4A156D7}",
										}, -- end of [1]
										[3] = 
										{
											["CLSID"] = "{3C612111-C7AD-476E-8A8E-2485812F4E5C}",
										}, -- end of [3]
										[4] = 
										{
											["CLSID"] = "{3C612111-C7AD-476E-8A8E-2485812F4E5C}",
										}, -- end of [4]
										[8] = 
										{
											["CLSID"] = "{3C612111-C7AD-476E-8A8E-2485812F4E5C}",
										}, -- end of [8]
										[9] = 
										{
											["CLSID"] = "{3C612111-C7AD-476E-8A8E-2485812F4E5C}",
										}, -- end of [9]
										[11] = 
										{
											["CLSID"] = "{682A481F-0CB5-4693-A382-D00DD4A156D7}",
										}, -- end of [11]
									}, -- end of ["pylons"]
									["fuel"] = "3790",
									["flare"] = 128,
									["chaff"] = 128,
									["gun"] = 100,
								}, -- end of ["payload"]
								["heading"] = -1.4896291831607,
								["callsign"] = 500,
								["onboard_num"] = '500',
							}, -- end of [1]
							[2] = 
							{
								["alt"] = 5000,
								["hardpoint_racks"] = true,
								["alt_type"] = "BARO",
								["livery_id"] = "su-25t test scheme",
								["skill"] = "Random",
								["speed"] = 282.63888888889,
								["type"] = "Su-25T",
								["y"] = spawnPoint.y,
								["x"] = spawnPoint.x+100,
								["name"] = unitName2,
								["payload"] = 
								{
									["pylons"] = 
									{
										[1] = 
										{
											["CLSID"] = "{682A481F-0CB5-4693-A382-D00DD4A156D7}",
										}, -- end of [1]
										[3] = 
										{
											["CLSID"] = "{3C612111-C7AD-476E-8A8E-2485812F4E5C}",
										}, -- end of [3]
										[4] = 
										{
											["CLSID"] = "{3C612111-C7AD-476E-8A8E-2485812F4E5C}",
										}, -- end of [4]
										[8] = 
										{
											["CLSID"] = "{3C612111-C7AD-476E-8A8E-2485812F4E5C}",
										}, -- end of [8]
										[9] = 
										{
											["CLSID"] = "{3C612111-C7AD-476E-8A8E-2485812F4E5C}",
										}, -- end of [9]
										[11] = 
										{
											["CLSID"] = "{682A481F-0CB5-4693-A382-D00DD4A156D7}",
										}, -- end of [11]
									}, -- end of ["pylons"]
									["fuel"] = "3790",
									["flare"] = 128,
									["chaff"] = 128,
									["gun"] = 100,
								}, -- end of ["payload"]
								["heading"] = -1.4896291831607,
								["callsign"] = 500,
								["onboard_num"] = '500',
							}, -- end of [1]
							[3] = 
							{
								["alt"] = 5000,
								["hardpoint_racks"] = true,
								["alt_type"] = "BARO",
								["livery_id"] = "su-25t test scheme",
								["skill"] = "Random",
								["speed"] = 282.63888888889,
								["type"] = "Su-25T",
								["y"] = spawnPoint.y,
								["x"] = spawnPoint.x+200,
								["name"] = unitName3,
								["payload"] = 
								{
									["pylons"] = 
									{
										[1] = 
										{
											["CLSID"] = "{682A481F-0CB5-4693-A382-D00DD4A156D7}",
										}, -- end of [1]
										[3] = 
										{
											["CLSID"] = "{3C612111-C7AD-476E-8A8E-2485812F4E5C}",
										}, -- end of [3]
										[4] = 
										{
											["CLSID"] = "{3C612111-C7AD-476E-8A8E-2485812F4E5C}",
										}, -- end of [4]
										[8] = 
										{
											["CLSID"] = "{3C612111-C7AD-476E-8A8E-2485812F4E5C}",
										}, -- end of [8]
										[9] = 
										{
											["CLSID"] = "{3C612111-C7AD-476E-8A8E-2485812F4E5C}",
										}, -- end of [9]
										[11] = 
										{
											["CLSID"] = "{682A481F-0CB5-4693-A382-D00DD4A156D7}",
										}, -- end of [11]
									}, -- end of ["pylons"]
									["fuel"] = "3790",
									["flare"] = 128,
									["chaff"] = 128,
									["gun"] = 100,
								}, -- end of ["payload"]
								["heading"] = -1.4896291831607,
								["callsign"] = 500,
								["onboard_num"] = '500',
							}, -- end of [1]
						}, -- end of ["units"]
						
					}},timer.getTime()+1)
					
					
					msn.currentCAPTargets = 3
	

	
	
end

function msn.cap_SpawnEnemyTransport()

				local randomSpawnZoneNumber = mist.random(5)
				local aircraftType = 'IL-76MD'
				local groupName = 'Red Transport Group ' .. msn.currentRedGroupNumber
				local unitName = 'Red Transport Unit ' .. msn.currentRedUnitNumber
				local spawnZone = trigger.misc.getZone('ai fighter spawn zone ' .. randomSpawnZoneNumber)
				local spawnPoint = mist.getRandPointInCircle(spawnZone.point, spawnZone.radius)
				local orbitZone = trigger.misc.getZone('Objective Zone')
				local orbitPoint = mist.getRandPointInCircle(orbitZone.point, 10)
				
				mist.scheduleFunction(mist.dynAdd,{{country = 'RUSSIA', category = 'AIRPLANE', --IL-76MD
				
					["tasks"] = 
					{
					}, -- end of ["tasks"]
					["radioSet"] = false,
					["task"] = "Transport",
					["taskSelected"] = true,
					["y"] = spawnPoint.y,
					["x"] = spawnPoint.x,
					["name"] = groupName,
					["communication"] = false,
					["route"] = 
					{
						["points"] = {
								[1] = 
								{
									["alt"] = 9144,
									["action"] = "Fly Over Point",
									["alt_type"] = "BARO",
									["speed"] = 180,
									["type"] = "Turning Point",
									["y"] = spawnPoint.y,
									["x"] = spawnPoint.x,
									["name"] = "DictKey_WptName_12",
									["task"] = 
									{
										["id"] = "ComboTask",
										["params"] = 
										{
											["tasks"] = 
											{
												[1] = 
												{
													["enabled"] = true,
													["auto"] = true,
													["id"] = "WrappedAction",
													["number"] = 1,
													["params"] = 
													{
														["action"] = 
														{
															["id"] = "Option",
															["params"] = 
															{
																["value"] = 0,
																["name"] = 1,
															}, -- end of ["params"]
														}, -- end of ["action"]
													}, -- end of ["params"]
												}, -- end of [1]
												[2] = 
												{
													["enabled"] = true,
													["auto"] = false,
													["id"] = "WrappedAction",
													["number"] = 2,
													["params"] = 
													{
														["action"] = 
														{
															["id"] = "Option",
															["params"] = 
															{
																["value"] = true,
																["name"] = 6,
															}, -- end of ["params"]
														}, -- end of ["action"]
													}, -- end of ["params"]
												}, -- end of [2]
											}, -- end of ["tasks"]
										}, -- end of ["params"]
									}, -- end of ["task"]
									

								}, -- end of [1]
								[2] = 
								{
									["alt"] = 9144,
									["action"] = "Turning Point",
									["alt_type"] = "BARO",
									["speed"] = 180,
									["task"] = 
									{
										["id"] = "ComboTask",
										["params"] = 
										{
											["tasks"] = 
											{
												[1] = 
												{
													["number"] = 1,
													["auto"] = false,
													["id"] = "Orbit",
													["enabled"] = true,
													["params"] = 
													{
														["altitude"] = 600,
														["pattern"] = "Circle",
														["speed"] = 138.88888888889,
													}, -- end of ["params"]
												}, -- end of [1]
											}, -- end of ["tasks"]
										}, -- end of ["params"]
									}, -- end of ["task"]
									["type"] = "Turning Point",
									["y"] = orbitPoint.y,
									["x"] = orbitPoint.x,
									["name"] = "DictKey_WptName_32",
								}, -- end of [2]
							}, -- end of ["points"]
					}, -- end of ["route"]
					["hidden"] = false,
					["units"] = 
					{
						[1] = 
						{
							["alt"] = 9144,
							["alt_type"] = "BARO",
							["livery_id"] = "RF Air Force",
							["skill"] = "Random",
							["speed"] = 180, --694.26388888889,
							["type"] = aircraftType,
							["y"] = spawnPoint.y,
							["x"] = spawnPoint.x,
							["name"] = unitName,
							["heading"] = 180,
							["callsign"] = 200+msn.currentRedUnitNumber,
							["onboard_num"] = '200',
							["payload"] = 
							{
								["pylons"] = 
								{
								}, -- end of ["pylons"]
								["fuel"] = "80000",
								["flare"] = 96,
								["chaff"] = 96,
								["gun"] = 100,
							}, -- end of ["payload"]
						}, -- end of [1]
					} -- end of ["units"]
				}},timer.getTime()+3)
				
				mist.scheduleFunction(msn.flagFunc_in_formation_enemy_transport,{unitName}, timer.getTime() + 5)

end

function msn.respawnAIChevy21()

	local groupName = 'Chevy 2'
	if Group.getByName(groupName) and Group.getByName(groupName):getSize() > 0 then
		msn.out(groupName .. ' is already active',5)
		return
	end
	
	if msn.missionPoints < 200 then
		msn.out('Insufficient mission points. Required: 200, Available: ' .. msn.missionPoints,5)
		return
	end
	
	msn.mpUpdate(-200, true)
	msn.out('Chevy 2 is on the way!',5)
	
	mist.scheduleFunction(mist.dynAdd,{{country = 'USA', category = 'HELICOPTER',
	
			["task"] = "CAS",
			["taskSelected"] = true,
			["y"] = 672558.91828572,
			["x"] = -292028.18107142,
			["name"] = "Chevy 2",
			["communication"] = true,
			["modulation"] = 0,
			["frequency"] = 254,
			["route"] = 
			{
				["routeRelativeTOT"] = true,
				["points"] = 
				{
					[1] = 
					{
						["alt"] = 13,
						["action"] = "From Parking Area Hot",
						["alt_type"] = "BARO",
						["linkUnit"] = 167,
						["helipadId"] = 167,
						["speed"] = 41.666666666667,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
									[1] = 
									{
										["number"] = 1,
										["auto"] = true,
										["key"] = "CAS",
										["id"] = "EngageTargets",
										["enabled"] = true,
										["params"] = 
										{
											["targetTypes"] = 
											{
												[1] = "Infantry",
												[2] = "Unarmed vehicles",
											}, -- end of ["targetTypes"]
											["maxDist"] = 7400,
											["priority"] = 0,
										}, -- end of ["params"]
									}, -- end of [1]
									[2] = 
									{
										["enabled"] = true,
										["auto"] = false,
										["id"] = "WrappedAction",
										["number"] = 2,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = 2,
													["name"] = 1,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [2]
									[3] = 
									{
										["enabled"] = true,
										["auto"] = false,
										["id"] = "WrappedAction",
										["number"] = 3,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = true,
													["name"] = 6,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [3]
									[4] = 
									{
										["enabled"] = true,
										["auto"] = false,
										["id"] = "WrappedAction",
										["number"] = 4,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = 0,
													["name"] = 10,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [4]
									[5] = 
									{
										["enabled"] = true,
										["auto"] = false,
										["id"] = "WrappedAction",
										["number"] = 5,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "Option",
												["params"] = 
												{
													["value"] = true,
													["name"] = 19,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [5]
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "TakeOffParkingHot",
						["ETA_locked"] = true,
						["y"] = 672558.91828572,
						["x"] = -292028.18107142,
						["name"] = "DictKey_WptName_1119",
						
						["speed_locked"] = true,
					}, -- end of [1]
					[2] = 
					{
						["alt"] = 243.84,
						["action"] = "Turning Point",
						["alt_type"] = "BARO",
						["speed"] = 55.555555555556,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "Turning Point",
						["ETA"] = 109.1819724864,
						["ETA_locked"] = false,
						["y"] = 689821.47285714,
						["x"] = -284537.30542858,
						["name"] = "DictKey_WptName_14",
						["formation_template"] = "",
						["speed_locked"] = true,
					}, -- end of [2]
					[3] = 
					{
						["alt"] = 243.84,
						["action"] = "Turning Point",
						["alt_type"] = "BARO",
						["speed"] = 23,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "Turning Point",
						["ETA"] = 132.71916600396,
						["ETA_locked"] = false,
						["y"] = 690453.67542857,
						["x"] = -283392.66800001,
						["name"] = "DictKey_WptName_9",
						["formation_template"] = "",
						["speed_locked"] = true,
					}, -- end of [3]
					[4] = 
					{
						["alt"] = 243.84,
						["action"] = "Turning Point",
						["alt_type"] = "BARO",
						["speed"] = 23,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "Turning Point",
						["ETA"] = 182.14606663838,
						["ETA_locked"] = false,
						["y"] = 688157.80885714,
						["x"] = -281886.28914286,
						["name"] = "DictKey_WptName_10",
						["formation_template"] = "",
						["speed_locked"] = true,
					}, -- end of [4]
					[5] = 
					{
						["alt"] = 243.84,
						["action"] = "Turning Point",
						["alt_type"] = "BARO",
						["speed"] = 23,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "Turning Point",
						["ETA"] = 207.334697025,
						["ETA_locked"] = false,
						["y"] = 687377.39571428,
						["x"] = -283047.83428572,
						["name"] = "DictKey_WptName_11",
						["formation_template"] = "",
						["speed_locked"] = true,
					}, -- end of [5]
					[6] = 
					{
						["alt"] = 243.84,
						["action"] = "Turning Point",
						["alt_type"] = "BARO",
						["speed"] = 23,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
									[1] = 
									{
										["enabled"] = true,
										["auto"] = false,
										["id"] = "WrappedAction",
										["number"] = 1,
										["params"] = 
										{
											["action"] = 
											{
												["id"] = "SwitchWaypoint",
												["params"] = 
												{
													["goToWaypointIndex"] = 3,
													["fromWaypointIndex"] = 5,
												}, -- end of ["params"]
											}, -- end of ["action"]
										}, -- end of ["params"]
									}, -- end of [1]
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "Turning Point",
						["ETA"] = 258.79581310732,
						["ETA_locked"] = false,
						["y"] = 689818.45542857,
						["x"] = -284536.06400001,
						["name"] = "DictKey_WptName_12",
						["formation_template"] = "",
						["speed_locked"] = true,
					}, -- end of [6]
					[7] = 
					{
						["alt"] = 29,
						["action"] = "Landing",
						["alt_type"] = "BARO",
						["linkUnit"] = 167,
						["helipadId"] = 167,
						["speed"] = 55,
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["type"] = "Land",
						["ETA_locked"] = false,
						["y"] = 672558.91828572,
						["x"] = -292028.18107142,
						["name"] = "DictKey_WptName_1182",
						
						["speed_locked"] = true,
					}, -- end of [5]
				}, -- end of ["points"]
			}, -- end of ["route"]
			["hidden"] = false,
			["units"] = 
			{
				[1] = 
				{
					["alt"] = 13,
					["hardpoint_racks"] = true,
					["alt_type"] = "BARO",
					["livery_id"] = "Georgian Air Force",
					["skill"] = "Excellent",
					["parking"] = 4,
					["ropeLength"] = 15,
					["speed"] = 41.666666666667,
					["AddPropAircraft"] = 
					{
						["EngineResource"] = 90,
						["NetCrewControlPriority"] = 1,
						["GunnersAISkill"] = 90,
						["ExhaustScreen"] = true,
					}, -- end of ["AddPropAircraft"]
					["type"] = "UH-1H",
					["parking_id"] = "1",
					["x"] = -292028.18107142,
					["y"] = 672558.91828572,
					["heading"] = 1.1230187166805,
					["name"] = "DictKey_UnitName_1118",
					["payload"] = 
					{
						["pylons"] = 
						{
							[1] = 
							{
								["CLSID"] = "M134_L",
							}, -- end of [1]
							[3] = 
							{
								["CLSID"] = "M134_SIDE_L",
							}, -- end of [3]
							[4] = 
							{
								["CLSID"] = "M134_SIDE_R",
							}, -- end of [4]
							[6] = 
							{
								["CLSID"] = "M134_R",
							}, -- end of [6]
						}, -- end of ["pylons"]
						["fuel"] = 568,
						["flare"] = 60,
						["chaff"] = 0,
						["gun"] = 100,
					}, -- end of ["payload"]
					["callsign"] = 
					{
						[1] = 7,
						[2] = 2,
						[3] = 1,
						["name"] = "Chevy21",
					}, -- end of ["callsign"]
					["onboard_num"] = "021",
				}, -- end of [1]
			}, -- end of ["units"]
			
	}},timer.getTime()+1)


end


function msn.respawnAIFACA()


	
		if Group.getByName(msn.facaGName) and Group.getByName(msn.facaGName):getSize() > 0 then
			msn.out('A FACA MQ-9 Reaper is already active',5)
			return
		end
	
		if msn.missionPoints < 200 then
			msn.out('Insufficient mission points. Required: 200, Available: ' .. msn.missionPoints,5)
			return
		end
		
	
		msn.mpUpdate(-200, true)
		msn.out('FACA MQ-9 Reaper is on the way!',5)
	
		msn.facaNextNumber = msn.facaNextNumber + 1
		msn.facaGName = 'FACA MQ-9 Reaper ' .. msn.facaNextNumber
		msn.facaUName = 'FACA ' .. msn.facaNextNumber

		mist.scheduleFunction(mist.dynAdd,{{country = 'USA', category = 'AIRPLANE',


								
                                ["task"] = "Reconnaissance",
                                ["taskSelected"] = true,
                                ["name"] = msn.facaGName,
                                ["communication"] = false,
								["start_time"] = 0,
								["y"] = 682401.25,
                                ["x"] = -284566.03125,
                                ["route"] = 
                                {
                                    ["points"] = 
                                    {
                                        [1] = 
                                        {
                                            ["alt"] = 45,
                                            ["action"] = "From Parking Area Hot",
                                            ["alt_type"] = "BARO",
                                            ["speed"] = 111,
                                            ["task"] = 
                                            {
                                                ["id"] = "ComboTask",
                                                ["params"] = 
                                                {
                                                    ["tasks"] = 
                                                    {
                                                        [1] = 
                                                        {
                                                            ["number"] = 1,
                                                            ["auto"] = true,
                                                            ["id"] = "WrappedAction",
                                                            ["enabled"] = true,
                                                            ["params"] = 
                                                            {
                                                                ["action"] = 
                                                                {
                                                                    ["id"] = "EPLRS",
                                                                    ["params"] = 
                                                                    {
                                                                        ["value"] = true,
                                                                        ["groupId"] = 1,
                                                                    }, -- end of ["params"]
                                                                }, -- end of ["action"]
                                                            }, -- end of ["params"]
                                                        }, -- end of [1]
                                                    }, -- end of ["tasks"]
                                                }, -- end of ["params"]
                                            }, -- end of ["task"]
                                            ["type"] = "TakeOffParkingHot",
                                            ["ETA_locked"] = true,
                                            ["y"] = 682401.25,
                                            ["x"] = -284566.03125,
                                            ["name"] = "DictKey_WptName_8",
                                            
                                            ["airdromeId"] = 25,
                                            ["speed_locked"] = true,
                                        }, -- end of [1]
                                        [2] = 
                                        {
                                            ["alt"] = 1199.9976,
                                            ["action"] = "Fly Over Point",
                                            ["alt_type"] = "RADIO",
                                            ["speed"] = 111,
                                            ["task"] = 
                                            {
                                                ["id"] = "ComboTask",
                                                ["params"] = 
                                                {
                                                    ["tasks"] = 
                                                    {
                                                        [1] = 
                                                        {
                                                            ["number"] = 1,
                                                            ["auto"] = false,
                                                            ["id"] = "Orbit",
                                                            ["enabled"] = true,
                                                            ["params"] = 
                                                            {
                                                                ["speedEdited"] = true,
                                                                ["pattern"] = "Circle",
                                                                ["speed"] = 40,
                                                                ["altitude"] = 3352.8,
                                                                ["altitudeEdited"] = true,
                                                            }, -- end of ["params"]
                                                        }, -- end of [1]
                                                    }, -- end of ["tasks"]
                                                }, -- end of ["params"]
                                            }, -- end of ["task"]
                                            ["type"] = "Turning Point",
                                            ["ETA_locked"] = false,
                                            ["y"] = 690951.026,
                                            ["x"] = -280423.43542857,
                                            ["name"] = "DictKey_WptName_10",
                                            
                                            ["speed_locked"] = true,
                                        }, -- end of [3]
                                        [3] = 
                                        {
                                            ["alt"] = 45,
                                            ["action"] = "Landing",
                                            ["alt_type"] = "BARO",
                                            ["speed"] = 111.11111111111,
                                            ["task"] = 
                                            {
                                                ["id"] = "ComboTask",
                                                ["params"] = 
                                                {
                                                    ["tasks"] = 
                                                    {
                                                    }, -- end of ["tasks"]
                                                }, -- end of ["params"]
                                            }, -- end of ["task"]
                                            ["type"] = "Land",
                                            ["ETA_locked"] = false,
                                            ["y"] = 683858.8125,
                                            ["x"] = -284887.375,
                                            ["name"] = "DictKey_WptName_11",
                                            
                                            ["airdromeId"] = 25,
                                            ["speed_locked"] = true,
                                        }, -- end of [4]
                                    }, -- end of ["points"]
                                }, -- end of ["route"]
                                ["units"] = 
                                {
                                    [1] = 
                                    {
										["speed"] = 111,
										["alt"] = 45,
                                        ["alt_type"] = "BARO",
                                        ["livery_id"] = "'camo' scheme",
                                        ["skill"] = "Excellent",
										["parking"] = "1",
										["parking_id"] = "15",
                                        ["name"] = msn.facaUName,
										["type"] = "MQ-9 Reaper",
										["payload"] = 
                                        {
                                            ["pylons"] = 
                                            {
                                            }, -- end of ["pylons"]
                                            ["fuel"] = "200",
                                            ["flare"] = 0,
                                            ["chaff"] = 0,
                                            ["gun"] = 100,
                                        }, -- end of ["payload"]
                                        ["y"] = 682401.25,
                                        ["x"] = -284566.03125,
										["heading"] = 1.6048868910927,
                                        ["callsign"] = 
                                        {
                                            [1] = 8,
                                            [2] = 1,
                                            [3] = 1,
                                            ["name"] = "Pontiac11",
                                        }, -- end of ["callsign"]
                                        ["onboard_num"] = "011",
                                    }, -- end of [1]
                                }, -- end of ["units"]

                            }},timer.getTime()+1)
							
							


end



function msn.cas_TargetInfo()

	msn.out(msn.strTargetInfo, 10)
	if msn.strTargetInfoSmoke ~= nil then
		msn.out(msn.strTargetInfoSmoke, 10)
	end
		
	

end

function msn.mpCheck()

	msn.out('Current Mission Points: '.. msn.missionPoints, 5)

end



function msn.out(outText, seconds)

	trigger.action.outText(outText, seconds)

end